activeGUI = true

local skinCache = ""
local eyesCache = ""
local hairCache = nil
local noncustomizebleCache = ""
local setColor = love.graphics.setColor

function GUI_load()
	for i,v in ipairs(playerTypeDatabase) do
		if v.name == player_character.chartype then
			skinCache = v.skin
			eyesCache = v.eyes
			hairCache = v.hair
			noncustomizebleCache = v.noncustomizeble
		end
	end
end

local vTransparency = 255
local vSTransparency = true
local fuel = 0

local function vehicle_gui_update()
	for i,v in ipairs(vehicle) do
		if v.inUse == true then
			fuel = math.ceil(v.fuel)
		end
	end
end

local function vehicle_gui()
	setColor(255,255,255,40)
	for i,v in ipairs(vehicle) do
		if v.inUse == true then
				love.graphics.rectangle("fill",210, 520, 200, 195)
				setColor(0,0,0,255)
				love.graphics.print("Vehicle stats: ",220,530)
				love.graphics.print("Name: " .. tostring(v.name),220,545)
				if fuel > 0 then
					love.graphics.print("Fuel: " .. tostring(fuel),220,560)
				else
					setColor(255,0,0,255)
					love.graphics.print("Fuel: Out of fuel!",220,560)
				end
			else
				if player.x > v.x -v.picture:getWidth()/2 -20 and
				player.x < v.x +v.picture:getWidth()/2 +20 and
				player.y > v.y -v.picture:getHeight()/2 -20 and
				player.y < v.y +v.picture:getHeight()/2 +20 then
					--love.graphics.print(""Enter" to get in",love.graphics.getWidth()/2,500,)
				end
 		end
	end
end

function GUI_draw()
	love.graphics.scale(scaleWidth,scaleHeight)
	love.graphics.draw(viginette,0,0)
	if activeGUI  == true then
		setColor(255,255,255,40)
		love.graphics.rectangle("fill",5,5,440,160)
		love.graphics.rectangle("fill",5,520,200,195)
		setColor(200,0,0)
		love.graphics.rectangle("fill",120,40,player.health*1.5,30)
		setColor(225,0,0,255)
		love.graphics.rectangle("fill",120,40,player.health*1.5,4)
		setColor(110,110,110)
		love.graphics.rectangle("line",120,40,300,30)
		setColor(20,20,20,255)
		
		love.graphics.setColor(20,200,20,180)
		love.graphics.rectangle("fill",850,680,player.stamina*2,15)
		love.graphics.setColor(1,1,1,255)
		love.graphics.rectangle("line",850,680,400,15)
		
		--love.graphics.print(tostring(love.joystick.getJoysticks()),500,2)
		love.graphics.print("Name: " .. tostring(player.name),120,80)
		love.graphics.print("Level: " .. tostring(player.level),120,100)
		love.graphics.print("Money: " .. tostring(player.money) .. " Rubels",120,120)
		if player.ammo > 100 then
			setColor(20,20,20)
			love.graphics.print("Ammunition: " .. tostring(player.ammo),20,525)
			else
			setColor(225,20,20)
			love.graphics.print("Ammunition: " .. tostring(player.ammo),20,525)
		end
		if player.rockets > 5 then
			setColor(20,20,20)
			love.graphics.print("Rockets: " .. tostring(player.rockets),20,540)
			else
			setColor(225,20,20)
			love.graphics.print("Rockets: " .. tostring(player.rockets),20,540)
		end
		
		--love.graphics.print(tostring(love.filesystem.read("map.arch")),0,0)
		
		--skin
		setColor(player_character.skin_color_r,player_character.skin_color_g,player_character.skin_color_b,255)
		love.graphics.draw(skinCache,20,20,0,2,2)
		--eyes
		setColor(player_character.eyes_color_r,player_character.eyes_color_g,player_character.eyes_color_b,255)
		love.graphics.draw(eyesCache,20,20,0,2,2)
		--hair
		
		if hairCache ~= nil then
			setColor(player_character.hair_color_r,player_character.hair_color_g,player_character.hair_color_b,255)
			love.graphics.draw(hairCache,20,20,0,2,2)
		end
			
		setColor(255,255,255,255)
		love.graphics.draw(noncustomizebleCache,20,20,0,2,2,0,0)
		
		for i,v in ipairs(weaponSlot) do
			if v.containment ~= "" then
				for l,w in ipairs(weapon) do
					if v.containment == w.name then
						setColor(255,255,255,255)
						love.graphics.draw(w.picture,10,520 + i*64,0,3,3)
						setColor(0,0,0,255)
						love.graphics.print(tostring(w.name),30,500 + i*64)
					end
				end
			end
		end
		setColor(0,0,0)
		love.graphics.print("FPS: " .. tostring(fps),0,0)
		setColor(255,255,255)
	end
	--vehicle_gui()
	enemy_spawner_wave_GUI()
	npc:draw_gui()
	love.graphics.scale(1,1)
end

function GUI_update(dt)
	fps = love.timer.getFPS()
	--vehicle_gui_update()
end


