
local blood = {}
local bloodpools = 0

function blood_spawn(x,y,size,maxsize)
	table.insert(blood,{x = x,y = y, size = size, maxsize = maxsize,ceiled = false,drawBlood = true})
	bloodpools = bloodpools + 1
end

local function blood_update_draw()
	for i,v in ipairs(blood) do
		if v.x > cameraX - v.size and
		v.x < cameraX + cameraWidth + v.size and
		v.y > cameraY - v.size and
		v.y < cameraY + cameraHeight + v.size then
			v.drawBlood = true
			else
			v.drawBlood = false
		end
	end
end

function blood_draw()
	if bloodpools > 0 then
		love.graphics.setColor(195,0,0)
		for i,v in ipairs(blood) do
			if v.drawBlood == true then
				love.graphics.circle("fill",v.x,v.y,v.size)
			end
		end
		love.graphics.setColor(255,255,255)
	end
end

local math_ceil = math.ceil

function blood_update(dt)
	blood_update_draw()
	if bloodpools > 0 then
		for i,v in ipairs(blood) do
			if v.size < v.maxsize then
				v.size = v.size + 20*dt
			else
				if v.ceiled == false then
					v.size = math_ceil(v.size)
					v.ceiled = true
				end
			end
		end
	end
end

function blood_reset()
	blood = {}
	bloodpools = 0
end