bullet = {}

local math_cos = math.cos
local math_sin = math.sin

function bullet_spawn(picture, angle, x, y, speed, damage, owner, sound)
	local j = {
		picture = picture,
		angle = angle,
		x = x,
		y = y,
		speed = speed,
		damage = damage,
		owner = owner,
		sound = sound,
		forward_x = 0,
		forward_y = 0,
		dx = 0,
		dy = 0,
		checked = false,
		checked2 = false,
		drawBullet = false
	}
	
	if j.checked == false then
		j.forward_x = math_cos(j.angle)
		j.forward_y = math_sin(j.angle)
		j.checked = true
	end

    table.insert(bullet, j)
	
	j.checked = false
end

local function bullet_check()
	for i,v in ipairs(bullet) do
		if v.checked2 == false then
			advancedSound_play(v.sound,true,v.x,v.y)
			v.checked2 = true 
		end	
		
		if v.x > cameraX - v.picture:getWidth()/2 and
		v.x < cameraX + v.picture:getWidth()/2 + cameraWidth and
		v.y > cameraY - v.picture:getHeight()/2 and
		v.y < cameraY + v.picture:getHeight()/2 + cameraHeight then
			v.drawBullet = true
		else
			v.drawBullet = false
		end
	end
end

function bullet_move(dt)
    for i,v in ipairs(bullet) do
        v.dx = 0
		v.dy = 0
		
		v.dx = v.dx + (v.forward_x * v.speed*dt)
        v.dy = v.dy + (v.forward_y * v.speed*dt)
		
		v.x = v.x + v.dx
        v.y = v.y + v.dy
   end
   bullet_check()
end

function bullet_draw()
    for i,v in ipairs(bullet) do
	    if v.drawBullet then
			love.graphics.draw(v.picture, v.x, v.y, v.angle, 1, 1, v.picture:getWidth() / 2, v.picture:getHeight() / 2)
		end
	end
end

function bullet_remove()
    for i,v in ipairs(bullet) do
		if v.x < cameraX - cameraWidth or v.x > cameraX + cameraWidth*3 or v.y < cameraY - cameraHeight or v.y > cameraY + cameraWidth*3 then
			table.remove(bullet,i)
		end
	end
end
