
local button = {}
layer = -1

function button_spawn(picture,picture2,x,y,text,tx,ty,drawstate,guiLayer,ignoreGUIlayer,id,bfont)
	table.insert(button,{picture = picture,picture2 = picture2,x = x,y = y,text = text,tx = tx,ty = ty,drawstate = drawstate,guiLayer = guiLayer,ignoreGUIlayer = ignoreGUIlayer,id = id or #buttons + 1,bfont = bfont,over = false})
end

function button_draw()
	for i,v in ipairs(button) do
		if v.drawstate == gamestate then
			if v.ignoreGUIlayer == false then
					if v.guiLayer == layer then
						love.graphics.setColor(255,255,255,255)
						if v.bfont ~= nil then
							love.graphics.setFont(v.bfont)
						else
							love.graphics.setFont(font)
						end
						if v.over == true then
							love.graphics.draw(v.picture2,v.x,v.y)
						else
							love.graphics.draw(v.picture,v.x,v.y)
						end
						love.graphics.setColor(0,0,0,255)
						if v.bfont ~= nil then
							love.graphics.print(v.text,v.x + v.picture:getWidth()/2,v.y + v.picture:getHeight()/2,0,1,1,v.bfont:getWidth(v.text)/2,v.bfont:getHeight(v.text)/2)
						else
							love.graphics.print(v.text,v.x + v.picture:getWidth()/2,v.y + v.picture:getHeight()/2,0,1,1,font:getWidth(v.text)/2,font:getHeight(v.text)/2)
						end
					end
				else
					love.graphics.setColor(255,255,255,255)
					if v.bfont ~= nil then
						love.graphics.setFont(v.bfont)
					else
						love.graphics.setFont(font)
					end
					if v.over == true then
						love.graphics.draw(v.picture2,v.x,v.y)
					else
						love.graphics.draw(v.picture,v.x,v.y)
					end
				love.graphics.setColor(0,0,0,255)
				if v.bfont ~= nil then
					love.graphics.print(v.text,v.x + v.picture:getWidth()/2,v.y + v.picture:getHeight()/2,0,1,1,v.bfont:getWidth(v.text)/2,v.bfont:getHeight(v.text)/2)
				else
					love.graphics.print(v.text,v.x + v.picture:getWidth()/2,v.y + v.picture:getHeight()/2,0,1,1,font:getWidth(v.text)/2,font:getHeight(v.text)/2)
				end
			end
		end
	end
end

function button_update()
	for i,v in ipairs(button) do
		if v.drawstate == gamestate then
			if v.ignoreGUIlayer == false then
				if v.guiLayer == layer then	
					if mouseX > scaleWidth * v.x and mouseX < scaleWidth * (v.x + v.picture:getWidth()) and
					mouseY > scaleHeight * v.y and mouseY < scaleHeight * (v.y + v.picture:getHeight()) then
						v.over = true
					else
						v.over = false
					end	
				end
			else
				if mouseX > scaleWidth * v.x and mouseX < scaleWidth * (v.x + v.picture:getWidth()) and
				mouseY > scaleHeight * v.y and mouseY < scaleHeight * (v.y + v.picture:getHeight()) then
						v.over = true
					else
						v.over = false
				end	
			end
		end
		if v.over == true then
			if v.id == "SurvivalMap1" then
				location = "s1"
			elseif v.id == "SurvivalMap2" then
				location = "s2"
			elseif v.id == "SurvivalMap3" then
				location = "s3"
			elseif v.id == "SurvivalMap4" then
				location = "s4"
			end
		end
	end	
end

function button_press(buttonId)
	if buttonId == 1 then
		for i,v in ipairs(button) do
			if v.drawstate == gamestate then
				if v.over == true then
					if v.id == "female" then
						player_character.chartype = "female"
					elseif v.id == "male" then
						player_character.chartype = "male"
					elseif v.id == "start" then
						if progress.createdCharacter == true then
							gamestate = "gamemodeSelection"
							GUI_load()
							layer = 1
						else
							gamestate = "cc"
							layer = -1
						end
					elseif v.id == "start2" then
						progress.createdCharacter = true
						gamestate = "gamemodeSelection"
						GUI_load()
						layer = 1
					elseif v.id == "credits" then
						gamestate = "credits"
					elseif v.id == "quit" then
						love.event.push("quit")
					elseif v.id == "options" then
						gamestate = "options"
					elseif v.id == "backtomenu" then
						gamestate = "menu"
						reset()
						pausedGame = false
					elseif v.id == "skin_1" then
						player_character.skin_color_r = 255
						player_character.skin_color_g = 225
						player_character.skin_color_b = 158
					elseif v.id == "skin_2" then
						player_character.skin_color_r = 255
						player_character.skin_color_g = 235
						player_character.skin_color_b = 158				
					elseif v.id == "skin_3" then
						player_character.skin_color_r = 255
						player_character.skin_color_g = 245
						player_character.skin_color_b = 158				
					elseif v.id == "skin_4" then
						player_character.skin_color_r = 216
						player_character.skin_color_g = 125
						player_character.skin_color_b = 69				
					elseif v.id == "skin_5" then
						player_character.skin_color_r = 183
						player_character.skin_color_g = 106
						player_character.skin_color_b = 58					
					elseif v.id == "skin_6" then
						player_character.skin_color_r = 168
						player_character.skin_color_g = 97
						player_character.skin_color_b = 53			
					elseif v.id == "eyes_1" then
						player_character.eyes_color_r = 81
						player_character.eyes_color_g = 31
						player_character.eyes_color_b = 0			
					elseif v.id == "eyes_2" then
						player_character.eyes_color_r = 0
						player_character.eyes_color_g = 135
						player_character.eyes_color_b = 13	
					elseif v.id == "eyes_3" then
						player_character.eyes_color_r = 0
						player_character.eyes_color_g = 120
						player_character.eyes_color_b = 206		
					elseif v.id == "hair_1" then
						player_character.hair_color_r = 107
						player_character.hair_color_g = 42
						player_character.hair_color_b = 0			
					elseif v.id == "hair_2" then
						player_character.hair_color_r = 198
						player_character.hair_color_g = 165
						player_character.hair_color_b = 0	
					elseif v.id == "hair_3" then
						player_character.hair_color_r = 129
						player_character.hair_color_g = 35
						player_character.hair_color_b = 0		
					elseif v.id == "hair_4" then
						player_character.hair_color_r = 240
						player_character.hair_color_g = 240
						player_character.hair_color_b = 240						
					elseif v.id == "skin" then
						layer = -1		
					elseif v.id == "eyes" then
						layer = -2	
					elseif v.id == "hair" then
						layer = -3	
					elseif v.id == "other" then
						layer = -4	
					elseif v.id == "help_map" then
						showMapHelp = not showMapHelp
					elseif v.id == "help_map_2" then
						showMapHelp2 = not showMapHelp2
					elseif v.id == "campaign" then
						gamestate = "map"
					elseif v.id == "skirmish" then
						gamestate = "skirmish"
					elseif v.id == "arcade" then
						gamestate = "arcade"
					elseif v.id == "multiplayer" then
						gamestate = "multiplayer_setup"
					elseif v.id == "website" then
						love.system.openURL( "http://radioactivegears.com/" )
					elseif v.id == "backtogamemodemenu" then
						gamestate = "gamemodeSelection"
					elseif v.id == "survivalmenu" then
						gamestate = "survivalmenu"
					elseif v.id == "backtoskirmishmenu" then
						gamestate = "skirmish"
					elseif v.id == "connect" then
						multiplayer_load()
						gamestate = "multiplayer"
					elseif v.id == "spawn" then
						multiplayer_player_spawn()
						layer = -1
					elseif v.id == "soldier" then
						mplayer.faction = "soldier"
					elseif v.id == "soldier_female" then
						mplayer.faction = "soldier_female"
					elseif v.id == "bandit" then
						mplayer.faction = "bandit"
					elseif v.id == "bandit_female" then
						mplayer.faction = "bandit_female"
					elseif v.id == "startmission" then
						missions_start()
					elseif v.id == "multiplayer_weapon1" then
						mplayer.weapon = "KHC-14"
					elseif v.id == "multiplayer_weapon2" then
						mplayer.weapon = "AVN-66"
					elseif v.id == "multiplayer_weapon3" then
						mplayer.weapon = "AVN-92"
					elseif v.id == "multiplayer_weapon4" then
						mplayer.weapon = "IO-43"
					elseif v.id == "backtomainmenu-options" then
						options_menu_load()
						gamestate = "menu"
					elseif v.id == "sRGB" then
						optionsTable.sRGB = not optionsTable.sRGB
					elseif v.id == "retinamode" then
						optionsTable.retinamode = not optionsTable.retinamode
					elseif v.id == "fullscreen" then
						optionsTable.fullscreen = not optionsTable.fullscreen
					elseif v.id == "particles" then
						optionsTable.particles = not gameOptionsTable.particles
					elseif v.id == "SFX" then
						gameOptionsTable.SFX = not gameOptionsTable.SFX
					elseif v.id == "Music" then
						gameOptionsTable.music = not gameOptionsTable.music
						music_options()
					elseif v.id == "sound+" then
						if gameOptionsTable.volume < 100 then
							gameOptionsTable.volume = gameOptionsTable.volume + 10
						end
					elseif v.id == "sound-" then
						if gameOptionsTable.volume > 0 then
							gameOptionsTable.volume = gameOptionsTable.volume - 10
						end
					elseif v.id == "increasemapsize" then
						if arcade_levelgen_params.mapsize < arcade_levelgen_params.largestmapsize then
							arcade_levelgen_params.mapsize = tonumber(math.ceil(arcade_levelgen_params.mapsize * 2))
						end
					elseif v.id == "decreasemapsize" then
						if arcade_levelgen_params.mapsize > arcade_levelgen_params.smallestmapsize then
							arcade_levelgen_params.mapsize = tonumber(math.ceil(arcade_levelgen_params.mapsize / 2))
						end
					elseif v.id == "startarcade" then
						arcade_generator(arcade_levelgen_params.mapsize)
					elseif v.id == "SurvivalMap1" then
						gamestate = "playing"
						location = "s1"
						maxWave = 10
						actiavtedWaveSystem = true
						currentWaveSpawnId = {"zombie","zombie2","zombie3"}
					elseif v.id == "SurvivalMap2" then
						gamestate = "playing"
						location = "s2"
						maxWave = 15
						actiavtedWaveSystem = true
						currentWaveSpawnId = {"bandit","bandit2","bandit3"}
					elseif v.id == "SurvivalMap3" then
						gamestate = "playing"
						location = "s3"
						maxWave = 20
						actiavtedWaveSystem = true
						currentWaveSpawnId = {"zombie_2","zombie2_2","zombie3_2"}
					elseif v.id == "SurvivalMap4" then
						gamestate = "playing"
						location = "s4"
						maxWave = 25
						actiavtedWaveSystem = true
						currentWaveSpawnId = {"bandit_2","bandit2_2","bandit3_2"}
					elseif v.id == "resume" then
						pausedGame = false
						layer = -1
					end
					v.over = false
				end
			end
		end	
	end
end
