
creditName = {}

local addY = 800
local creditsSpeed = 100
local creditsHeight = love.graphics.getHeight()
local creditsWidth = love.graphics.getWidth()

local waitTime = 2
local waitTimer = 0

function credits_add_name(text,extraSpace)
	table.insert(creditName,{text = text,extraSpace = extraSpace,x = creditsWidth/2,y = addY,originalY = addY,checked = false, id = #creditName + 1})
	for i,v in ipairs(creditName) do
		if v.checked == false then
			addY = addY + v.extraSpace + 5 + font50:getHeight(v.text)
			v.checked = true
		end
	end
end

function credits_draw()
	love.graphics.setColor(0,0,0,255)
	for i,v in ipairs(creditName) do
		if v.y > 0 - font50:getHeight(v.text) and v.y < creditsHeight then
			love.graphics.setFont(font50)
			love.graphics.print(v.text,v.x,v.y,0,1,1,font50:getWidth(v.text)/2)
		end
	end
end

function credits_update(dt)
	for i,v in ipairs(creditName) do
		v.y = v.y - creditsSpeed*dt

		-- This timing isn't perfect and doesn't have to be
		if v.id == #creditName and v.y < 0 then
			waitTimer = waitTimer + dt
			if waitTimer >= waitTime then
				credits_reset()
				gamestate = "menu"
			end
		end
	end

	if love.keyboard.isDown("escape") then
		credits_reset()
		gamestate = "menu"
	end
end

function credits_reset()
	for i,v in ipairs(creditName) do
		v.y = v.originalY
	end
end

function credits_load()
	credits_add_name("Thanks for playing this game!",20)
	credits_add_name("Programmers: ",0)
	credits_add_name("Lead Developer: Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",10)
	credits_add_name("Artists: ",20)
	credits_add_name("Creative Designer: Gustava Geisler",0)
	credits_add_name("Eamonn Dev Rea",0)
	credits_add_name("Eamonn Dev Rea",0)
	credits_add_name("Eamonn Dev Rea",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",10)
	credits_add_name("Test Team: ",20)
	credits_add_name("Head of Test Team: Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",10)
	credits_add_name("Marketing Team: ",20)
	credits_add_name("Marketing Expert: Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",0)
	credits_add_name("Gustava Geisler",30)
	credits_add_name("Thanks to OSX expert Eamonn Rea (sonic2kk)",0)
	credits_add_name("Thanks to David Khachaturov",0)
	credits_add_name("Thanks to Simon Rahnasto for being awesome",0)
	credits_add_name("Thanks to Emma Bjoerg for the idea behind the 'collector' ",0)
end