dmgText = {}
local red1 = {255, 0, 0}
local red2 = {127, 0, 0}

local math_random = love.math.random
local math_setRandomSeed = love.math.setRandomSeed

function spawnText(text, x, y)
	if love._os ~= "Android" then
		math_setRandomSeed(math.random(-os.time() * math_random(1, 200), os.time() * math_random(1, 200)))
	end
	
	local i = {
		x = x + math_random(-30, 30),
		y = y + math_random(-20, 20),
		text = text,
		r = math.rad(math_random(1, 40)),
		t = 0,
		tm = (math_random(3, 10)) / 10,
		speed = math_random(50, 80),
		vx = math_random(-1, 1),
		vy = math_random(-1, 1),
	}
	
	table.insert(dmgText, i)
end

function drawText()
	love.graphics.setFont(font50)
	for i,v in ipairs(dmgText) do
		love.graphics.setColor(red1)
		love.graphics.print(v.text, v.x, v.y, v.r)
		
		love.graphics.setColor(red2)
		love.graphics.print(v.text, v.x, v.y, v.r)
	end
	
	love.graphics.setColor(255, 255, 255)
	love.graphics.setFont(font)
end

function updateText(dt)
	for i,v in ipairs(dmgText) do
		v.t = v.t + dt
		v.x = v.x + v.vx * v.speed * dt
		v.y = v.y + v.vy * v.speed * dt
		
		if v.t >= v.tm then
			table.remove(dmgText, i)
		end
	end
end