
enemy = {}

local math_random = love.math.random
local math_ceil = math.ceil
local math_rad = math.rad

function enemy_spawn(picture,picture2,frames,x,y,speed,health,moveToHitboxX,moveToHitboxY,direction,attackType,spawnblood,bloodsize,bloodsizemax,weaponId,weaponX,weaponY,damage,found,dlocation,isWaveMonster,moneydrop1,moneydrop2,useWaypoint,waypointType,waypointMode,currentWaypoint,waypointTableX,waypointTableY)
	local e = {
		picture = picture,
		picture2 = picture2,
		frames = frames,
		x = x,
		y = y,
		speed = speed,
		health = health,
		moveToHitboxX = moveToHitboxX,
		moveToHitboxY = moveToHitboxY,
		direction = direction,
		attackType = attackType,
		spawnblood = spawnblood,
		bloodsizemax = bloodsizemax,
		bloodsize = bloodsize,
		weaponId = weaponId,
		weaponX = weaponX,
		weaponY = weaponY,
		weaponCooldown = 0,
		damage = damage,
		found = found,
		dlocation = dlocation,
		animation = "",
		moving = false,
		checked = false,
		isWaveMonster = isWaveMonster,
		moneydrop1 = moneydrop1,
		moneydrop2 = moneydrop2,
		enemyUpdate = true,
		enemyDraw = false,
		weaponPicture = "",
		useWaypoint = useWaypoint,
		waypointType = waypointType,
		waypointMode = waypointMode,
		currentWaypoint = currentWaypoint,
		waypointTableX = waypointTableX,
		waypointTableY = waypointTableY,
		currentSpeed = speed
	}
	
	table.insert(enemy,e)
	
	enemy_check()
end

function enemy_check()
	for i,v in ipairs(enemy) do
		if v.checked == false then
			if v.isWaveMonster == nil then
				v.isWaveMonster = false
			end
			v.animation = newAnimation(v.picture2, v.picture:getWidth(),v.picture:getHeight(), 0.11, v.frames)
			v.animation:setMode("loop")
			if v.weaponId ~= "" then
				for l,w in ipairs(weapon) do
					if v.weaponId == w.name then
						v.weaponPicture = w.picture
					end
				end
			end
			v.checked = true
		end
	end
	totalEnemiesSpawned = totalEnemiesSpawned + 1
end

local function enemy_update_sleep()
	for i,v in ipairs(enemy) do
		if v.dlocation == location then
			v.enemyUpdate = true
		else
			v.enemyUpdate = false
		end
		if v.dlocation == location then
			if v.x > cameraX - v.picture:getWidth()/2 and
			v.x < cameraX + v.picture:getWidth()/2 + cameraWidth and
			v.y > cameraY - v.picture:getHeight()/2 and
			v.y < cameraY + v.picture:getHeight()/2 + cameraHeight then
					v.enemyDraw = true
				else
					v.enemyDraw = false
			end
		end
	end
end

function enemy_draw()
	for i,v in ipairs(enemy) do
		if v.enemyDraw == true then
			--love.graphics.setColor(0,0,0)
			--love.graphics.print(tostring(v.found),v.x,v.y -30)
			--love.graphics.setColor(255,255,255)
			if v.moving == false then
				love.graphics.draw(v.picture,v.x,v.y,0,v.direction,1,v.picture:getWidth()/2,v.picture:getHeight()/2)
			else
				v.animation:draw(v.x,v.y,0,v.direction,1,v.picture:getWidth()/2,v.picture:getHeight()/2)
			end
			if v.weaponId ~= "" then
				if v.direction == 1 then
					love.graphics.draw(v.weaponPicture,v.x + v.weaponX,v.y + v.weaponY,0,v.direction,1,v.weaponPicture:getWidth()/2,v.weaponPicture:getHeight()/2)
				else
					love.graphics.draw(v.weaponPicture,v.x - v.weaponX,v.y +v.weaponY,0,v.direction,1,v.weaponPicture:getWidth()/2,v.weaponPicture:getHeight()/2)
				end
			end
		end
	end
end

local math_sqrt = math.sqrt

function enemy_move(dt)
	for i,v in ipairs(enemy) do
		if v.dlocation == location then
			if v.moving == true then
				v.animation:update(dt)
			end
			
			if v.found == true then
				if v.x > player.x - v.moveToHitboxX and
				v.x < player.x + v.moveToHitboxX and
				v.y > player.y - v.moveToHitboxY and
				v.y < player.y + v.moveToHitboxY then
					
					v.moving = false
				else
	  
					local dx = player.x - v.x
					local dy = player.y - v.y
			
					local length = math_sqrt(dx*dx+dy*dy)
					dx = dx/length
					dy = dy/length
		  
					v.x=v.x + v.currentSpeed*dx*dt
					v.y=v.y + v.currentSpeed*dy*dt
					
					v.moving = true
				end
				
				if player.x > v.x then
					v.direction = 1
				else
					v.direction = -1
				end
			else
				if v.useWaypoint == true then
					if v.x > v.waypointTableX[v.currentWaypoint] then
						v.direction = -1
					else
						v.direction = 1
					end
						
					if v.x > v.waypointTableX[v.currentWaypoint] - v.picture:getWidth()*2 and
					v.x < v.waypointTableX[v.currentWaypoint] + v.picture:getWidth()*2 and
					v.y > v.waypointTableY[v.currentWaypoint] - v.picture:getHeight()*2 and
					v.y < v.waypointTableY[v.currentWaypoint] + v.picture:getHeight()*2 then
						if v.waypointMode == true then
							v.currentWaypoint = v.currentWaypoint + 1
						elseif v.waypointMode == false then
							v.currentWaypoint = v.currentWaypoint - 1
						end
						v.moving = false
					else
						local dx = v.waypointTableX[v.currentWaypoint] - v.x
						local dy = v.waypointTableY[v.currentWaypoint] - v.y
		  
						local length = math_sqrt(dx*dx+dy*dy)
						dx = dx/length
						dy = dy/length
		  
						v.x=v.x + v.currentSpeed*dx*dt
						v.y=v.y + v.currentSpeed*dy*dt
					
						v.moving = true							
					end
						
					if v.waypointType == "repeat" then
						if v.currentWaypoint > #v.waypointTableX then
							v.currentWaypoint = v.currentWaypoint - 1
							v.waypointMode = not v.waypointMode
						elseif v.currentWaypoint == 1 then
							v.waypointMode = true
						end
					end
				end
			end
		end
	end
end

local function enemy_shoot(dt)
	for i,v in ipairs(enemy) do
		if v.enemyUpdate then
			if v.attackType == "ranged" then
				if v.y > player.y - player_character.height and
				v.y < player.y + player_character.height  and
				v.x > player.x - cameraWidth and
				v.x < player.x + cameraWidth and
				v.weaponCooldown < 1 and
				v.found == true then
					for o,w in ipairs(weapon) do
						if v.weaponId == w.name then
							if v.direction == -1 then
								bullet_spawn(w.bulletPicture, math_rad(180 - math_random(-w.spread,w.spread)), v.x - 5 - w.bulletPicture:getWidth(), v.y + v.weaponY-3, w.speed, w.damage, "enemy", w.sound)
							elseif v.direction == 1 then
								bullet_spawn(w.bulletPicture, math_rad(0 - math_random(-w.spread,w.spread)), v.x + 5 + w.bulletPicture:getWidth(), v.y + v.weaponY -3, w.speed, w.damage, "enemy", w.sound)
							end
							if v.weaponCooldown < 3 then
								v.weaponCooldown = v.weaponCooldown + 500*dt
							end
						end
					end
				end		
				if v.weaponCooldown > 0 then
					v.weaponCooldown = v.weaponCooldown - 20*dt
				end
			end
		end
	end
end

local function enemy_damage_player(dt)
	for i,v in ipairs(enemy) do
		if v.enemyUpdate then
			if v.found == true then
				if v.attackType == "melee" then
					if v.x > player.x - v.moveToHitboxX and
					v.x < player.x + v.moveToHitboxX and
					v.y > player.y - v.moveToHitboxY and
					v.y < player.y + v.moveToHitboxY then
						if player.health > -2 then
							player.health = player.health - v.damage*dt
						end
					end
				end
			end
		end
	end
end

local function enemy_hit_by_bullet(dt)
	for i,v in ipairs(enemy) do
		if v.enemyUpdate then
			for l,w in ipairs(bullet) do
				if w.owner == "player" then
					if w.x > v.x - v.picture:getWidth()/2 and
					w.x < v.x + v.picture:getWidth()/2 and
					w.y > v.y - v.picture:getHeight()/2 and
					w.y < v.y + v.picture:getHeight()/2 then
						local dmg = math_random(w.damage - 1, w.damage + 1)
						v.health = v.health - dmg
						spawnText(tostring(dmg), v.x, v.y)
						v.found = true
						stat_shotshit = stat_shotshit + 1
						table.remove(bullet,l)
					end
				end
			end
			for l,w in ipairs(missiles) do
				if w.owner == "player" then
					if w.x > v.x - v.picture:getWidth()/2 and
					w.x < v.x + v.picture:getWidth()/2 and
					w.y > v.y - v.picture:getHeight()/2 and
					w.y < v.y + v.picture:getHeight()/2 then
						local dmg = math_random(w.damage - 1, w.damage + 1)
						v.health = v.health - dmg
						spawnText(tostring(dmg), v.x, v.y)
						v.found = true
						stat_shotshit = stat_shotshit + 1
						explosion_spawn(explosion_spritesheet,w.x,w.y,0.03,10,128,128)
						table.remove(missiles,l)
					end	
				end
			end
			if v.health <= 0 then
				if v.spawnblood == true then
					blood_spawn(math_ceil(v.x),math_ceil(v.y),v.bloodsize,v.bloodsizemax)
				end
				if v.isWaveMonster == true then
					--Note to self this is part of the wave system
					killedEnemies = killedEnemies + 1
				end
				
				advancedSound_play(deathsound,true,v.x,v.y,"")
				
				corpse_spawn(v.picture,math_ceil(v.x),math_ceil(v.y),v.direction)
				
				totalEnemiesSpawned = totalEnemiesSpawned - 1
				
				local moneyGivenToPlayer = math_random(v.moneydrop1,v.moneydrop2)
				player.money = player.money + moneyGivenToPlayer
				stat_moneyearned = stat_moneyearned + moneyGivenToPlayer
				
				stat_kills = stat_kills + 1
				
				table.remove(enemy,i)
			end
		end
	end
end

local function enemy_find_player()
	for i,v in ipairs(enemy) do
		if v.enemyUpdate then
			for j,q in ipairs(noise) do
				if v.x > q.x and
				v.x < q.x + q.width and
				v.y > q.y and
				v.y < q.y + q.height then
					if q.noiselevel == 1 then
						if v.direction == 1 then
							v.direction = -1
						elseif v.direction == -1 then
							v.direction = 1
						end
					elseif q.noiselevel == 2 then
						v.found = true
					end
				end
			end
			if player.y > v.y - v.picture:getHeight()*1.5 and
			player.y < v.y + v.picture:getHeight()*1.5 then
				if v.direction == 1 then
					if player.x < v.x + cameraWidth/2 and
					player.x > v.x then
						v.found = true
					end
				elseif v.direction == -1 then
					if player.x > v.x - cameraWidth/2 and
					player.x < v.x then
						v.found = true
					end
				end
			end
		end
	end
end

local function enemy_collide(dt)
	for i,v in ipairs(enemy) do
		if v.enemyUpdate then
			for l,w in ipairs(enemy) do
				if w.enemyUpdate then
					--left
					if w.x > v.x - v.picture:getWidth()/1.5 and
					w.x < v.x and
					w.y > v.y - v.picture:getHeight()/1.5 and
					w.y < v.y + v.picture:getHeight()/1.5 then
						w.x = w.x - v.currentSpeed/2*dt 
					elseif
					w.x > v.x - v.picture:getWidth()/1.5 and
					w.x < v.x and
					w.y > v.y - v.picture:getHeight()/1.5 and
					w.y < v.y + v.picture:getHeight()/1.5 then
						w.x = w.x - v.currentSpeed/2*dt 
					end
			
					--right
					if w.x < v.x - v.picture:getWidth()/1.5 and
					w.x > v.x and
					w.y > v.y - v.picture:getHeight()/1.5 and
					w.y < v.y + v.picture:getHeight()/1.5 then
						w.x = w.x + v.currentSpeed/2*dt 
					elseif
					w.x < v.x - v.picture:getWidth()/1.5 and
					w.x > v.x and
					w.y > v.y - v.picture:getHeight()/1.5 and
					w.y < v.y + v.picture:getHeight()/1.5 then
						w.x = w.x + v.currentSpeed/2*dt 	
					end
				end
			end
		end
	end
end

function enemy_update(dt)
	enemy_shoot(dt)
	enemy_damage_player(dt)
	enemy_hit_by_bullet(dt)
	enemy_find_player()
	enemy_collide(dt)
	enemy_update_sleep()
	enemy_move(dt)
end
