local math_random = love.math.random

explosion = {}

function explosion_spawn(spritesheet,x,y,speed,frames,frameSizeX,frameSizeY)
	table.insert(explosion,{spritesheet = spritesheet,x = x,y = y,animation = "",speed = speed,frames = frames,frameSizeX = frameSizeX,frameSizeY = frameSizeY,checked = false})
	for i,v in ipairs(explosion) do
		if v.checked == false then
			v.x = v.x -math_random(-5,5)
			v.y = v.y -math_random(-5,5)
			v.animation = newAnimation(v.spritesheet, v.frameSizeX, v.frameSizeY, v.speed, v.frames)
			v.animation:setMode("once")
			advancedSound_play(explosionSound,true,v.x,v.y,"")
			v.checked = true
		end
	end
end

function explosion_draw()
	for i,v in ipairs(explosion) do
		if v.checked == true then
			v.animation:draw(v.x -v.frameSizeX/2,v.y -v.frameSizeY/2)
		end
	end
end

function explosion_update(dt)
	for i,v in ipairs(explosion) do
		if v.checked == true then
			v.animation:update(dt)
			if v.animation:getCurrentFrame() >= v.frames then
				table.remove(explosion,i)
			end
		end
	end
end