local shake = {}

shake.shake = {}

local math_random = love.math.random

function shake:set()
	love.graphics.push()
	for i,v in ipairs(self.shake) do
		v.mag = v.mag or 0
		love.graphics.translate(math_random(-v.mag, v.mag), math_random(-v.mag, v.mag))
		-- love.graphics.rotate(math.rad(love.math.random(-v.mag/2, v.mag/2)))
	end
end

function shake:unset()
	love.graphics.pop()
end

function shake:startShake(time, magnitude)
	local i = {}
	i.timer = -1
	i.time = time/2
	i.mag = magnitude/4
	
	table.insert(self.shake, i)
end

function shake:update(dt)
	for i,v in ipairs(self.shake) do
		v.timer = v.timer + dt
		
		if v.timer >= v.time then
			table.remove(self.shake, i)
		end
	end
end

return shake