
local mission_location = ""

local progress = 0

map = "USSR1"

inMission = false
currentObjective = ""
currentMission = ""

showMapHelp = false
showMapHelp2 = false

mission = {}

function mission_add(belongingMap,name,description,missionType,missionData,picture,completed_picture,mlocation,x,y,unlocked,unlockAtProgress)
	table.insert(mission,{belongingMap = belongingMap,name = name,description = description,missionType = missionType,missionData = missionData,picture = picture,completed_picture = completed_picture,mlocation = mlocation,x = x,y = y,unlocked = unlocked,unlockAtProgress = unlockAtProgress,completed = "false",selected = false})
end

backgroundMap = {}

function backgroundMap_add(ID,picture)
	table.insert(backgroundMap,{ID = ID,picture = picture})
end

function missions_load()
	map_background = love.graphics.newImage("assets/images/campaign/map.png")
	map_ussr = love.graphics.newImage("assets/images/campaign/map_ussr.png")
	map_ussr2 = love.graphics.newImage("assets/images/campaign/map_ussr_train.png")
	flag_zombie = love.graphics.newImage("assets/images/campaign/flag_zombie.png")
	flag_bandit = love.graphics.newImage("assets/images/campaign/flag_bandit.png")
	flag_soviet = love.graphics.newImage("assets/images/campaign/flag_soviet.png")
	flag_star = love.graphics.newImage("assets/images/campaign/star.png")
	target = love.graphics.newImage("assets/images/campaign/target.png")
	icon_complete = love.graphics.newImage("assets/images/campaign/complete.png")
	icon_incomplete = love.graphics.newImage("assets/images/campaign/incomplete.png")
	
	backgroundMap_add("USSR1",map_ussr)
	backgroundMap_add("USSR2",map_ussr2)
	mission_add("USSR1","Operation Red November","Hello I am comrade General David I'll giving you orders from now on. We have gotten reports of strange creatures attacking villages in this area. The reports are most likely just some nonsense made by some drunk Ukranian officials but we have to be sure, so we're sending you out to investigate it.","wave",{5},flag_zombie,flag_soviet,"m1",190,120,true,"")
	mission_add("USSR1","Operation Blood Square","So that was unexpected we're under attack by 'zombies' and they're already near Moscow. You know how to deal with these so called 'zombies' so I'm going to send you to Moscow to protect the kremlin. We cannot allow the Red Square to fall to the army of undead that would mean the collapse of the entire union.","wave",{7},flag_zombie,flag_soviet,"Moscow",280,140,false,"Operation Red November")
	mission_add("USSR1","Operation Cuban Cigars","The city of Samara exploded when gas workers were interrupted by zombies, most of the city is gone however we must look for survivors and kill all intruders! ","wave",{10},flag_zombie,flag_soviet,"m3",340,185,false,"Operation Blood Square")
	mission_add("USSR1","Operation Ghost","Leningrad has been taken over by bandits we must take this strategic location back!","sneak",{},flag_bandit,flag_soviet,"m4",317,77,false,"Operation Cuban Cigars")
	mission_add("USSR1","Operation Highrise","The City of Orenburg is an important city in the south Russian SSR we cannot allow it to fall!","wave",{12},flag_zombie,flag_soviet,"m5",355,250,true,"")
	mission_add("USSR1","Operation Red Star","The SSR of Azerbaijan have requested our help to take back Baku","wave",{16},flag_zombie,flag_soviet,"Baku",214,299,true,"Operation Red November")
	mission_add("USSR1","Operation Victory Train","This small railyard is crucial to our transport system, we can't lose it!","wave",{20},flag_zombie,flag_soviet,"railyard",514,279,true,"Operation Red November")
	
	mission_add("USSR1","Camp Pesha","At this location you can buy new weapons and supplies","camp",{},flag_star,flag_star,"Pesha",425,130,false,"Operation Red November")
	mission_add("USSR1","Camp Korliki","At this location you can buy new weapons and supplies","camp",{},flag_star,flag_star,"Korliki",617,280,false,"Operation Ghost")
end

function missions_draw()
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(map_background,0,0)
	for i,v in ipairs(backgroundMap) do
		if v.ID == map then
			love.graphics.draw(v.picture,119,0)
		end
	end
	--love.graphics.draw(map_ussr,119,0)
	for i,v in ipairs(mission) do
		if v.belongingMap == map then
			if v.completed == "false" then
				love.graphics.draw(v.picture,v.x,v.y)
			else
				love.graphics.draw(v.completed_picture,v.x,v.y)
			end
			if v.selected == true then
				love.graphics.setColor(255,255,255,255)
				love.graphics.draw(target,v.x,v.y)
				love.graphics.setFont(font50)
				love.graphics.print(v.name,220,490)
				love.graphics.setFont(font)
				love.graphics.printf(v.description,220,530,850)
				if v.completed == "false" then
					love.graphics.draw(icon_incomplete,140,500)
				elseif v.completed == "true" then
					love.graphics.draw(icon_complete,140,500)
				end
			else
				if mouseX > scaleWidth * v.x +4 and mouseX < scaleWidth * (v.x + v.picture:getWidth()) -4 and
				mouseY > scaleHeight * v.y +4 and mouseY < scaleHeight * (v.y + v.picture:getHeight()) -4 then
					love.graphics.setColor(255,255,255,100)
					love.graphics.draw(target,v.x,v.y)
					love.graphics.setColor(255,255,255,255)
				end
			end
		end
	end
	if showMapHelp == true then
		love.graphics.setFont(font)
		love.graphics.setColor(0,0,0,110)
		love.graphics.rectangle("fill",990,5,165,165)
		love.graphics.setColor(200,0,0,255)
		love.graphics.rectangle("fill",995,10,24,24)
		love.graphics.setColor(230,230,230,255)
		love.graphics.rectangle("fill",995,36,24,24)
		love.graphics.setColor(110,110,110,255)
		love.graphics.rectangle("fill",995,62,24,24)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print(" = Russian SSR",1024,15)
		love.graphics.print(" = SSR States",1024,40)
		love.graphics.print(" = Foreign States",1024,65)
	end
	if showMapHelp2 == true then
		love.graphics.setColor(0,0,0,110)
		love.graphics.rectangle("fill",990,175,165,200)
	end
	--love.graphics.print(location,5,5)
end

function missions_start()
	gamestate = "playing"
	inMission = true
	for i,v in ipairs(mission) do
		if v.selected == true then
			currentMission = v.name
			currentObjective = v.missionType
			if v.missionType == "wave" then
				maxWave = v.missionData[1]
				actiavtedWaveSystem = true
			elseif v.missionType == "rescue" then
				
			elseif v.missionType == "sneak" then
					
			elseif v.missionType == "boss" then
					
			elseif v.missionType == "special" then
					
			end
		end
	end
end

function missions_update(dt)
	if love.keyboard.isDown("return") then
		missions_start()
	end
end

function missions_abandon()
	inMission = false
	currentObjective = ""
	currentMission = ""
end

function missions_mouse(x,y,button)
	if button == 1 then
		for i,v in ipairs(mission) do
			if mouseX > scaleWidth * v.x +4 and mouseX < scaleWidth * (v.x + v.picture:getWidth()) -4 and
			mouseY > scaleHeight * v.y +4 and mouseY < scaleHeight * (v.y + v.picture:getHeight()) -4 then
				v.selected = true
				
				mission_location = v.mlocation
				location = mission_location
				startlocation = mission_location
				else
				v.selected = false
				
			end
		end
	end
end