mbullet = {}
mbullets = {}

local math_cos = math.cos
local math_sin = math.sin

function mbullet_spawn( angle, x, y, speed, damage, owner,sound)
	table.insert(mbullet,{angle = angle,x = x,y = y,speed = speed,damage = damage,owner = owner,forward_x = 0,forward_y = 0,dx = 0,dy = 0,sound = sound,playedSound = false,checked = false})
	
	for i,v in ipairs(mbullet) do
		if v.checked == false then
			v.forward_x = math_cos(v.angle)
			v.forward_y = math_sin(v.angle)			
			v.checked = true
		end
	end
	mbullet.dataType = "spawnBullet"
	local bulletData = table.serialize(mbullet,true,true)
	client:send(bulletData)
	table.remove(mbullet)
	collectgarbage()
end

function mbullet_move(dt)
    for i,v in ipairs(mbullets) do
		v.dx = 0
		v.dy = 0
		
		v.dx = v.dx + (v.forward_x * v.speed*dt)
		v.dy = v.dy + (v.forward_y * v.speed*dt)
		
		v.x = v.x + v.dx
		v.y = v.y + v.dy
		
		if v.x > cameraX - bullet_1:getWidth()/2 and
		v.x < cameraX + bullet_1:getWidth()/2 + cameraWidth and
		v.y > cameraY - bullet_1:getHeight()/2 and
		v.y < cameraY + bullet_1:getHeight()/2 + cameraHeight then
			v.draw = true
		else
			v.draw = false
		end
	end
end

function mbullet_draw()
    for i,v in ipairs(mbullets) do
		if v.draw == true then
			love.graphics.setColor(255,255,255)
		    love.graphics.draw(bullet_1, v.x, v.y, v.angle, 1, 1, bullet_1:getWidth() / 2, bullet_1:getHeight() / 2)
		end
	end
end

function mbullet_remove()
    for i,v in ipairs(mbullets) do
		if v.x < -2800 then
			table.remove(mbullets,i)
		elseif v.x > 2800 then
			table.remove(mbullets,i)
		end
		if v.y < -500 then
			table.remove(mbullets,i)
		elseif v.y > 1500 then
			table.remove(mbullets,i)
		end
	end
end

function mbullet_damage(dt)
	for t,v in ipairs(mbullets) do
		if v.x > mplayer.x - 32 / 2 and
		v.x < mplayer.x + 32 / 2 and
		v.y > mplayer.y - 64 / 2 and
		v.y < mplayer.y + 64 / 2 and
		mplayer.dead == false and
		mplayer.spawnProtection == false then
			if v.owner ~= mainplayer then
				mplayer.health = mplayer.health -v.damage
				v.removeb = true
				table.remove(mbullets,i)
            end				
		end
		for t,w in ipairs(players) do
			if v.x > w.x - 32 / 2 and
			v.x < w.x + 32 / 2 and
			v.y > w.y - 64 / 2 and
			v.y < w.y + 64 / 2 and
			w.dead == false and
			v.owner ~= w.nickname and
			v.owner == mainplayer then
				spawnText(v.damage, w.x, w.y)
				table.remove(mbullets,i)
			end
		end
	end
end

function bullet_recieve(data)
	local datasTable = loadstring(data)()
	if datasTable.dataType == "clientSpawnBullet" then
		--print("Received bullet from server")
		table.insert(mbullets,datasTable)
		for i,v in ipairs(mbullets) do
			if v.playedSound == false then
				advancedSound_play("",true,v.x,v.y,v.sound)
				v.playedSound = true
			end
		end
	end
end
