npc = {}

function npc:spawn(picture,x,y,direction,text,name,dlocation,id,weaponId,weaponX,weaponY)
	local i = {
		picture = picture,
		x = x,
		y = y,
		direction = direction,
		tbtimer = 0,
		text = text,
		name = name,
		dlocation = dlocation,
		id = id,
		weaponId = weaponId,
		weaponX = weaponX,
		weaponY = weaponY,
		curtext = "",
		lookTimer = 7,
		drawNPC = "",
		drawNPCText = false,
	}
	
	table.insert(npc,i)
end

function npc:draw_update()
	for i,v in ipairs(npc) do
		if v.dlocation == location then
			if v.x > cameraX -v.picture:getWidth() and
			v.x < cameraX + cameraWidth + v.picture:getWidth()/2 and
			v.y > cameraY -v.picture:getHeight() and
			v.y < cameraY + cameraHeight + v.picture:getHeight()/2 then
				if player.y < v.y + v.picture:getHeight()/7 then
					v.drawNPC = "1"
				else
					v.drawNPC = "2"
				end
				v.drawNPCText = true
				v.drawNPC = true
				else
				v.drawNPC = false
			end
		else
			v.drawNPC = false
			v.drawNPCText = false
		end
	end
end


function npc:draw()
	for i,v in ipairs(npc) do
		if v.drawNPC then	
			love.graphics.draw(v.picture,v.x,v.y,0,v.direction,1,v.picture:getWidth()/2)
				
			for k,w in ipairs(weapon) do
				if w.name == v.weaponId then
					love.graphics.draw(w.picture,v.x +w.x +1 + v.weaponX,v.y +20 + v.weaponY,0,v.direction,1,v.picture:getWidth()/2)	    
				end
			end
		end
	end
end

function npc:draw2()
	for i,v in ipairs(npc) do
		if v.drawNPC == "1" then	
			love.graphics.draw(v.picture,v.x,v.y,0,v.direction,1,v.picture:getWidth()/2)	
			for k,w in ipairs(weapon) do
				if w.name == v.weaponId then
					love.graphics.draw(w.picture,v.x +w.x +1 + v.weaponX,v.y +20 + v.weaponY,0,v.direction,1,v.picture:getWidth()/2)    
				end
			end
		end
	end
end

function npc:draw_text()
	love.graphics.setColor(0,0,0,255)
	for i,v in ipairs(npc) do
		if v.drawNPCText then	
			if gamestate == "playing" then
				love.graphics.setColor(0,0,0,255)
				love.graphics.print(v.name,v.x,v.y - 35,0,1,1,font:getWidth(v.name)/2,font:getHeight(v.name)/2)
			end
			if v.tbtimer > 0 then
				love.graphics.setColor(0,0,0,255)
				love.graphics.rectangle("fill",v.x -font:getWidth(v.curtext)/2,v.y -10 - font:getHeight(v.curtext),font:getWidth(v.curtext),font:getHeight(v.curtext),0,1,1,font:getWidth(v.curtext)/2,font:getHeight(v.curtext)/2)
				love.graphics.setColor(255,255,255,255)
				love.graphics.printf(v.curtext,v.x -font:getWidth(v.curtext)/2,v.y -10 - font:getHeight(v.curtext),900,"left",0,1,1)
			end
		end
	end	
	love.graphics.setColor(255,255,255,255)
end

function npc:look()
	for i,v in ipairs(npc) do	
		if v.dlocation == location then
			if player.x > v.x - 64 and player.x < v.x + 128 + player_character.width and
			player.y > v.y - 96 and player.y < v.y + 128 + player_character.height then
				if player.x < v.x then
					v.direction = -1
				elseif player.x > v.x + v.picture:getWidth() then
					v.direction = 1
				end
			end
		end
	end
end

function npc:talk(dt)
	for i,v in ipairs(npc) do
		if v.dlocation == location then
			if v.tbtimer > 0 then
				v.tbtimer = v.tbtimer - 10 * dt 
			else
				v.tbtimer = 0
			end
		end
	end
end

local math_random = love.math.random

function npc:randomlookdirection(dt)
	for i,v in ipairs(npc) do
		if player.x > v.x - 64 and player.x < v.x + 128 + player_character.width and
			player.y > v.y - 96 and player.y < v.y + 128 + player_character.height then
			
			else
			if v.lookTimer < 0 then
				local look = math_random(-1,1)
				if look ~= 0 then
					v.direction = look
				end
				v.lookTimer = math_random(80,140)
			end
			v.lookTimer = v.lookTimer - 60*dt
		end
	end
end

function npc:functions(dt)
	npc:talk(dt)
	npc:look()
	npc:randomlookdirection(dt)
end

function npc:triggertext(key)
	if key == keys.talk then
		for i,v in ipairs(npc) do
			if v.dlocation == location then
				if player.x > v.x - 32 and player.x < v.x + 32 + player_character.width and
				player.y > v.y - 32 and player.y < v.y + 32 + player_character.height then
				
					local choose = math_random(1,#v.text)
			
					v.tbtimer = 25
					v.curtext = v.text[choose]

				end
			end
		end
	end
end

function npc:triggertext_joystick(button)
	if button == 2 then
		for i,v in ipairs(npc) do
			if v.dlocation == location then
				if player.x > v.x - 32 and player.x < v.x + 32 + player_character.width and
				player.y > v.y - 32 and player.y < v.y + 32 + player_character.height then
				
					local choose = math_random(1,#v.text)
			
					v.tbtimer = 25
					v.curtext = v.text[choose]

				end
			end
		end
	end
end

function npc:special(key)
	if key == keys.accept then
		for i,v in ipairs(npc) do
			if v.dlocation == location then
				if player.x > v.x - 32 and player.x < v.x + 32 + player_character.width and
				player.y > v.y - 32 and player.y < v.y + 32 + player_character.height then
						if v.id == "shop" then
							player.allowedToMove = false
							activeGUI = false
							shop = true
						end
				end
			end
		end
	end
end

function npc:draw_gui()
	love.graphics.setColor(0,0,0,255)
	for i,v in ipairs(npc) do
		if v.dlocation == location then
			if player.x > v.x - 32 and player.x < v.x + 32 + player_character.width and
			player.y > v.y - 32 and player.y < v.y + 32 + player_character.height then
				love.graphics.print("Press 'E' to speak with NPC",cameraWidth/2,420,0,1,1,font:getWidth("Press 'E' to speak with NPC")/2)
				if v.id == "shop" then
					love.graphics.print("Press 'A' to trade with NPC",cameraWidth/2,440,0,1,1,font:getWidth("Press 'A' to trade with NPC")/2)
				end
			end
		end
	end
	love.graphics.setColor(255,255,255,255)
end