
objects = {}

function objects_stay_spawn(picture,x,y,rotation,scaleh,scalew,id,dlocation,isBackground,width,height)
	j = {
	picture = picture,
	x = x,
	y = y,
	rotation = rotation,
	scaleh = scaleh,
	scalew = scalew,
	id = id,
	dlocation = dlocation,
	isBackground = isBackground,
	width = width,
	height = height,
	objectDraw = true,
	objectDrawTop = true,
	checked = false
	}
	table.insert(objects,j)
end

local math_ceil = math.ceil
local draw_graphics = love.graphics.draw

function objects_update()
	if gamestate == "multiplayer" then
		for i,v in ipairs(objects) do
			if v.x > cameraX - v.width/2 and
			v.x < cameraX + cameraWidth + v.width/2 and
			v.y > cameraY - v.height/2 and
			v.y < cameraY + cameraHeight + v.height/2 and
			v.dlocation == location then
				v.objectDraw = true	
			else
				v.objectDraw = false
			end
			if v.objectDraw == true then
				for x,q in ipairs(players) do
					if q.x > v.x -v.width/2 and q.x < v.x + v.width/2 then
						if q.y < v.y + v.height/2 - player_character.height/2 then
							v.objectDrawTop = true
						elseif q.y > v.y + v.height/2 - player_character.height/2 then
							v.objectDrawTop = false
						end
					end
				end
				if v.isBackground == true then
					v.objectDrawTop = false
				end
			end
		end
	else
		for i,v in ipairs(objects) do
			if v.x > cameraX - v.width/2 and
			v.x < cameraX + cameraWidth + v.width/2 and
			v.y > cameraY - v.height/2 and
			v.y < cameraY + cameraHeight + v.height/2 and
			v.dlocation == location then
				v.objectDraw = true	
			else
				v.objectDraw = false
			end
			if v.objectDraw == true then
				if player.x > v.x -v.width/2 and player.x < v.x + v.width/2 then
					if player.y < v.y + v.height/2 - player_character.height/2 then
						v.objectDrawTop = true
					elseif player.y > v.y + v.height/2 - player_character.height/2 then
						v.objectDrawTop = false
					end
				end
				if v.isBackground == true then
					v.objectDrawTop = false
				end
			end
		end		
	end
end

function objects_load()
	for i,v in ipairs(objects) do
		if v.checked == false then
			v.x = math_ceil(v.x)
			v.y = math_ceil(v.y)
			v.checked = true
		end
	end
end

function objects_draw()
	for i,v in ipairs(objects) do
		if v.objectDraw then
			if v.isBackground == false then
				if v.objectDrawTop then
					draw_graphics(v.picture,v.x,v.y,v.rotation,v.scaleh,v.scalew,v.picture:getWidth()/2,v.picture:getHeight()/2)
				end
			end
		end
	end
end

function objects_draw_background()
	for i,v in ipairs(objects) do
		if v.objectDraw then
			if not v.isBackground then
				if not v.objectDrawTop then
					draw_graphics(v.picture,v.x,v.y,v.rotation,v.scaleh,v.scalew,v.picture:getWidth()/2,v.picture:getHeight()/2)
				end
			end
		end
	end
end

function objects_draw_background_static()
	for i,v in ipairs(objects) do
		if v.objectDraw then
			if v.isBackground then
				draw_graphics(v.picture,v.x,v.y,v.rotation,v.scaleh,v.scalew,v.picture:getWidth()/2,v.picture:getHeight()/2)
			end
		end
	end
end

function objects_interact()
	for i,v in ipairs(objects) do
		if v.dlocation == location then
		
		end
	end
end