
objects_stay = {}

function objects_stay_spawn(pictureId,x,y,rotation,scaleh,scalev,id,dlocation,isBackground,alight,width,height)
	j = {
	pictureId = pictureId,
	x = x,
	y = y,
	rotation = rotation,
	scaleh = scaleh,
	scalev = scalev,
	id = id,
	dlocation = dlocation,
	isBackground = isBackground,
	width = width,
	height = height,
	objectDraw = true,
	objectDrawTop = true,
	checked = false,
	}
	table.insert(objects_stay,j)
end

local math_ceil = math.ceil

function objects_stay_update()
	if gamestate == "multiplayer" then
		for i,v in ipairs(objects_stay) do
			if v.dlocation == location then
				if v.x > cameraX - v.width/2 and
				v.x < cameraX + cameraWidth + v.width/2 and
				v.y > cameraY - v.height/2 and
				v.y < cameraY + cameraHeight + v.height/2 and
				v.dlocation == location then
					v.objectDraw = true	
					else
					v.objectDraw = false
				end
			else
				v.objectDraw = false
			end
			if v.objectDraw == true then
				for x,q in ipairs(players) do
					if q.x > v.x -v.width/2 and q.x < v.x + v.width/2 then
						if q.y < v.y + v.height/2 - player_character.height/2 then
							v.objectDrawTop = true
						elseif q.y > v.y + v.height/2 - player_character.height/2 then
							v.objectDrawTop = false
						end
					end
				end
				if v.isBackground == true then
					v.objectDrawTop = false
				end
			end
		end
	else
		for i,v in ipairs(objects_stay) do
			if v.dlocation == location then
				if v.x > cameraX - v.width/2 and
				v.x < cameraX + cameraWidth + v.width/2 and
				v.y > cameraY - v.height/2 and
				v.y < cameraY + cameraHeight + v.height/2 and
				v.dlocation == location then
					v.objectDraw = true	
					else
					v.objectDraw = false
				end
			else
				v.objectDraw = false
			end
			if v.objectDraw == true then
				for l,w in ipairs(enemy) do
					if w.x > v.x -v.width/2 and w.x < v.x + v.width/2 then
						if w.y < v.y + v.height/2 - w.picture:getHeight()/2 then
							v.objectDrawTop = true
						elseif w.y > v.y + v.height/2 - w.picture:getHeight()/2 then
							v.objectDrawTop = false
						end
					end
				end
				if player.x > v.x -v.width/2 and player.x < v.x + v.width/2 then
					if player.y < v.y + v.height/2 - player_character.height/2 then
						v.objectDrawTop = true
					elseif player.y > v.y + v.height/2 - player_character.height/2 then
						v.objectDrawTop = false
					end
				end
				if v.isBackground == true then
					v.objectDrawTop = false
				end
			end
		end		
	end
end

function objects_stay_load()
	for i,v in ipairs(objects_stay) do
		if v.checked == false then
			for o,w in ipairs(image) do
				if v.pictureId == w.id then
					v.picture = w.picture
				end
			end
			v.x = math_ceil(v.x)
			v.y = math_ceil(v.y)
			v.drawCentrationX = v.picture:getWidth()/2
			v.drawCentrationY = v.picture:getHeight()/2
			v.checked = true
		end
	end
end

function objects_stay_draw()
	for i,v in ipairs(objects_stay) do
		if v.objectDraw then
			if not v.isBackground then
				if v.objectDrawTop then
					love.graphics.draw(v.picture,v.x,v.y,v.rotation,v.scaleh,v.scalev,v.drawCentrationX,v.drawCentrationY)
				end
			end
		end
	end
end

function objects_stay_draw_background()
	for i,v in ipairs(objects_stay) do
		if v.objectDraw then
			if not v.isBackground then
				if not v.objectDrawTop then
					love.graphics.draw(v.picture,v.x,v.y,v.rotation,v.scaleh,v.scalev,v.drawCentrationX,v.drawCentrationY)
				end
			end
		end
	end
end

function objects_stay_draw_background_static()
	for i,v in ipairs(objects_stay) do
		if v.objectDraw then
			if v.isBackground then
				love.graphics.draw(v.picture,v.x,v.y,v.rotation,v.scaleh,v.scalev,v.drawCentrationX,v.drawCentrationY)
			end
		end
	end
end

function objects_stay_interact()
	for i,v in ipairs(objects_stay) do
		if v.dlocation == location then
			if player.x > v.x -v.width/2 and
			player.x < v.x +v.width/2 and
			player.y > v.y -v.height/2 and
			player.y < v.y +v.height/2 then
				if v.id == "map" then
					if love.keyboard.isDown("a") then
						gamestate = "gamemodeSelection"
					end
				end
			end
		end
	end
end