
particles = {}

function particles_spawn(picture,x,y,speedX,speedY,ignoreCamera,timer)
	table.insert(particles,{picture = picture,x = x,y = y,speedX = speedX,speedY = speedY,ignoreCamera = ignoreCamera,timer = timer})
end

local draw = love.graphics.draw
local table_remove = table.remove

function particles_draw_igonore_camera()
	for i,v in ipairs(particles) do
		if v.ignoreCamera == true then
			draw(v.picture,v.x,v.y)
		end
	end
end

function particles_draw_camera()
	for i,v in ipairs(particles) do
		if v.ignoreCamera == false then
			draw(v.picture,v.x,v.y)
		end		
	end
end

local function particles_move(dt)
	for i,v in ipairs(particles) do
		v.x = v.x + v.speedX*dt
		v.y = v.y + v.speedY*dt
	end
end

local function particles_remove(dt)
	for i,v in ipairs(particles) do
		if v.ignoreCamera == true then
				if v.x < 0 or v.y < 0 or v.x > cameraWidth or v.y > cameraHeight then
					--collectgarbage()
					table_remove(particles,i)
				end
			else
				v.timer = v.timer - 100*dt
				if v.timer <= 0 then
					--collectgarbage()
					table_remove(particles,i)
				end
		end
	end
end

function particles_update(dt)
	particles_move(dt)
	particles_remove(dt)
end
