player = {
	x = 600,
	y = 450,
	name = "",
	health = 200,
	level = 1,
	speed = 125,
	stamina = 200,
	direction = 1,
	money = 5000,
	ammo = 400,
	rockets = 10,
	weapon = "AVN-66",
	allowedToMove = true,
	allowedToDraw = true,
	gasmask = false,
	gasmaskOn = false,
	moving = false,
	spawnX = 600,
	spawnY = 450
}


playerTypeDatabase = {}

function player_type_add(name,noncustomizeble,spritesheet,skin,eyes,hair,animation,animationFrames)
	table.insert(playerTypeDatabase,{name = name,noncustomizeble = noncustomizeble,spritesheet = spritesheet,skin = skin,eyes = eyes,hair = hair,animation = animation,animationFrames = animationFrames})
	for i,v in ipairs(playerTypeDatabase) do
		v.animation = newAnimation(v.spritesheet, v.noncustomizeble:getWidth(),v.noncustomizeble:getHeight(), 0.1, animationFrames)
		v.animation:setMode("loop")
	end
end

player_character = {
	chartype = "female",
	name = "",

	skin_color_r = 255,
	skin_color_g = 225,
	skin_color_b = 158,
	
	eyes_color_r = 99,
	eyes_color_g = 39,
	eyes_color_b = 0,
	
	hair_color_r = 99,
	hair_color_g = 39,
	hair_color_b = 0,
	
	width = 32,
	height = 64
}

weaponSlot = {}

local weaponSlotId = 1
selectedWeaponSlot = 1

function weaponSlot_add(containment,key)
	table.insert(weaponSlot,{containment = containment,key = key,id = weaponSlotId})
	weaponSlotId = weaponSlotId + 1
end

local function weaponSlot_update()
	for i,v in ipairs(weaponSlot) do
		if love.keyboard.isDown(v.key) then
			player.weapon = v.containment
			selectedWeaponSlot = v.id
		end
	end
end

function player_load()
	player_type_add("female",char_female_noncustomizeble,char_female_spritesheet,char_female_skin,char_female_eyes,char_female_hair,1,8)
	player_type_add("male",char_male_noncustomizeble,char_male_spritesheet,char_male_skin,char_male_eyes,nil,1,8)
	for i,v in ipairs(playerTypeDatabase) do
		if v.name == player_character.chartype then
			player_character.width = v.noncustomizeble:getWidth()
			player_character.height = v.noncustomizeble:getHeight()
		end
	end
	weaponSlot_add("AVN-66","1")
	weaponSlot_add("AN-7A","2")
end

function player_draw()
	if player.allowedToDraw == true then
		love.graphics.setColor(0,0,0,255)
		love.graphics.print(player_character.name,player.x,player.y - player_character.height/2 - 5,0,1,1,font:getWidth(player_character.name)/2,font:getHeight(player_character.name)/2)
		love.graphics.setColor(255,255,255,255)
		for i,v in ipairs(playerTypeDatabase) do
			if v.name == player_character.chartype then
				--skin
				love.graphics.setColor(player_character.skin_color_r,player_character.skin_color_g,player_character.skin_color_b)
				love.graphics.draw(v.skin,player.x,player.y,0,player.direction,1,v.noncustomizeble:getWidth()/2,v.noncustomizeble:getHeight()/2)
				--eyes
				love.graphics.setColor(player_character.eyes_color_r,player_character.eyes_color_g,player_character.eyes_color_b)
				love.graphics.draw(v.eyes,player.x,player.y,0,player.direction,1,v.noncustomizeble:getWidth()/2,v.noncustomizeble:getHeight()/2)
				--hair
				if v.hair ~= nil then
					love.graphics.setColor(player_character.hair_color_r,player_character.hair_color_g,player_character.hair_color_b)
					love.graphics.draw(v.hair,player.x,player.y,0,player.direction,1,v.noncustomizeble:getWidth()/2,v.noncustomizeble:getHeight()/2)
				end
			
				love.graphics.setColor(255,255,255,255)

				if player.moving == false then
						love.graphics.draw(v.noncustomizeble,player.x,player.y,0,player.direction,1,v.noncustomizeble:getWidth()/2,v.noncustomizeble:getHeight()/2)
					else
						v.animation:draw(player.x, player.y, 0, player.direction,1,v.noncustomizeble:getWidth()/2,v.noncustomizeble:getHeight()/2)
				end
			end
		end
	end
end


function player_update(dt)
	weaponSlot_update()
	player_getShot(dt)
	love.audio.setPosition( player.x, player.y, 0)
	if player.allowedToMove == true then
		if joystickOn == true then
			local direction = joystick:getHat(1)
		
			if direction == "u" then
				player.y = player.y -player.speed*dt
			elseif direction == "d" then
				player.y = player.y +player.speed*dt
			end
			if direction == "l" then
				player.x = player.x -player.speed*dt
				player.direction = -1
			elseif direction == "r" then
				player.x = player.x +player.speed*dt
				player.direction = 1
			end
			if direction == "ld" then
				player.x = player.x -player.speed*dt
				player.y = player.y +player.speed*dt
				player.direction = -1
			elseif direction == "lu" then
				player.x = player.x -player.speed*dt
				player.y = player.y -player.speed*dt
				player.direction = -1
			end
			if direction == "rd" then
				player.x = player.x +player.speed*dt
				player.y = player.y +player.speed*dt
				player.direction = 1
			elseif direction == "ru" then
				player.x = player.x +player.speed*dt
				player.y = player.y -player.speed*dt
				player.direction = 1
			end
			
			if love.keyboard.isDown("left") or love.keyboard.isDown("right") or love.keyboard.isDown("up") or love.keyboard.isDown("down") or direction == "u" or direction == "l" or direction == "d" or direction == "r" or direction == "ld" or direction == "lu" or direction == "rd" or direction == "ru"  then
				player.moving = true
			else
				player.moving = false
			end
			
			else
			
			if love.keyboard.isDown("left") or love.keyboard.isDown("right") or love.keyboard.isDown("up") or love.keyboard.isDown("down") then
				player.moving = true
			else
				player.moving = false
			end
		end
	
		if love.keyboard.isDown("up") then
			player.y = player.y -player.speed*dt
		elseif love.keyboard.isDown("down") then
			player.y = player.y +player.speed*dt
		end
		if love.keyboard.isDown("left") then
			player.x = player.x -player.speed*dt
			player.direction = -1
		elseif love.keyboard.isDown("right") then
			player.x = player.x +player.speed*dt
			player.direction = 1
		end
		
		if love.keyboard.isDown("lshift") then
			if player.stamina > 0 then
				player.speed = 200
				player.stamina = player.stamina - 50*dt
			else
				player.speed = 125
			end
		else
			player.speed = 125
			if player.stamina < 200 then
				player.stamina = player.stamina + 100*dt
			end
		end
		else
		player.moving = false
	end
	
	if player.moving == true then
		for i,v in ipairs(playerTypeDatabase) do
			if v.name == player_character.chartype then
				v.animation:update(dt)
			end
		end
	end
end

function player_getShot(dt)
	for i,v in ipairs(bullet) do
		if v.owner ~= "player" then
			if v.x > player.x -player_character.width/2 and
			v.x < player.x +player_character.width/2 and
			v.y > player.y -player_character.height/2 and
			v.y < player.y +player_character.height/2 then
				player.health = player.health - v.damage/2
				table.remove(bullet,i)
			end
		end
	end
end

function player_die()
	if player.health <= 0 then
		player.x, player.y = player.spawnX, player.spawnY
		if player.ammo < 200 then
			player.ammo = 200
		end
		if player.money > 30 then
			player.money = player.money - 30
		end

		player.health = 200
		
		gamestate = "deathscreen"
	end
end

function player_reset()
	player.x = 600
	player.y = 450	
end
