totalEnemiesSpawned = 0
maxEnemiesInWorld = 100

local math_random = love.math.random

local enemy_type_database = {}

function enemy_type_database_add(id,picture,picture2,frames,mspeed,health,moveToHitboxX,moveToHitboxY,attackType,spawnblood,bloodsize, bloodsizemax,weapon,weaponX,weaponY,damage,found,dlocation,moneydrop1,moneydrop2)
	local j = {
		id = id,
		picture = picture,
		picture2 = picture2,
		frames = frames,
		mspeed = mspeed,
		health = health,
		moveToHitboxX = moveToHitboxX,
		moveToHitboxY = moveToHitboxY,
		attackType = attackType,
		spawnblood = spawnblood,
		bloodsize = bloodsize,
		bloodsizemax = bloodsizemax,
		weapon = weapon,
		weaponX = weaponX,
		weaponY = weaponY,
		damage = damage,
		found = found,
		dlocation = dlocation,
		moneydrop1 = moneydrop1,
		moneydrop2 = moneydrop2
	}
	table.insert(enemy_type_database,j)
end

function enemy_type_database_load()
	enemy_type_database_add("zombie",zombie,zombie_spritesheet,8,80,10,48,10,"melee",true,20, 30,"",0,0,80,true,"wasteland",10,16)
	enemy_type_database_add("zombie2",zombie2,zombie2_spritesheet,8,80,10,48,10,"melee",true,20, 30,"",0,0,80,true,"wasteland",10,16)
	enemy_type_database_add("zombie3",zombie3,zombie3_spritesheet,8,80,10,48,10,"melee",true,20, 30,"",0,0,80,true,"wasteland",10,16)
	
	enemy_type_database_add("zombie_2",zombie,zombie_spritesheet,8,80,20,48,10,"melee",true,20, 30,"",0,0,80,true,"wasteland",10,16)
	enemy_type_database_add("zombie2_2",zombie2,zombie2_spritesheet,8,80,20,48,10,"melee",true,20, 30,"",0,0,80,true,"wasteland",10,16)
	enemy_type_database_add("zombie3_2",zombie3,zombie3_spritesheet,8,80,20,48,10,"melee",true,20, 30,"",0,0,80,true,"wasteland",10,16)
	
	enemy_type_database_add("zombie_nonwave",zombie,zombie_spritesheet,8,80,4,48,10,"melee",true,20, 30,"",0,0,80,false,"wasteland",10,16)
	
	enemy_type_database_add("bandit",bandit,bandit_spritesheet,8,80,10,48,10,"ranged",true,20, 30,"KHC-14",0,10,80,true,"wasteland",10,16)
	enemy_type_database_add("bandit2",bandit,bandit_spritesheet,8,80,10,48,10,"melee",true,20, 30,"",0,10,80,true,"wasteland",10,16)
	enemy_type_database_add("bandit3",bandit_female,bandit_female_spritesheet,8,80,10,48,10,"ranged",true,20, 30,"KHC-14",0,10,80,true,"wasteland",10,16)
	enemy_type_database_add("bandit_2",bandit,bandit_spritesheet,8,80,20,48,10,"ranged",true,20, 30,"AVN-68",0,10,80,true,"wasteland",10,16)
	enemy_type_database_add("bandit2_2",bandit,bandit_spritesheet,8,80,20,48,10,"melee",true,20, 30,"",0,10,80,true,"wasteland",10,16)
	enemy_type_database_add("bandit3_2",bandit_female,bandit_female_spritesheet,8,80,20,48,10,"ranged",true,20, 30,"AVN-68",0,10,80,true,"wasteland",10,16)
end

actiavtedWaveSystem = false
wave = 0
maxWave = 10
inWave = true
timer_wave = -1
currentWaveSpawnId = {"zombie","zombie2","zombie3"}
local CurrentID = 2
maxEnemies = 4
killedEnemies = 0
local spawned = 0
local checked = false

function enemy_spawner_wave_GUI()
	if actiavtedWaveSystem == true then
		love.graphics.setColor(0,0,0)
		love.graphics.print("Wave: " .. tostring(wave) .. "/" .. tostring(maxWave),460,5)
		if inWave == true then
			love.graphics.print("In wave!",460,25)	
		else
			if timer_wave > 6 then
				love.graphics.setFont(font)
				love.graphics.print("Timer: " .. tostring(timer_wave),460,25)	
			else
				love.graphics.setFont(font50)
				if wave >= maxWave then
					love.graphics.print("Mission ending in:",love.graphics.getWidth()/2,love.graphics.getHeight()/2 -105,0,1,1,font50:getWidth("Mission ending in:")/2)	
					love.graphics.print(tostring(timer_wave),love.graphics.getWidth()/2,love.graphics.getHeight()/2 -70,0,1,1,font50:getWidth(timer_wave)/2)				
				else
					love.graphics.print("Next wave begins in:",love.graphics.getWidth()/2,love.graphics.getHeight()/2 -105,0,1,1,font50:getWidth("Next wave begins in:")/2)	
					love.graphics.print(tostring(timer_wave),love.graphics.getWidth()/2,love.graphics.getHeight()/2 -70,0,1,1,font50:getWidth(timer_wave)/2)
				end
				love.graphics.setFont(font)
			end
		end
		--love.graphics.print("Kills this wave: " .. tostring(killedEnemies),460,45)
	end
end

function enemy_spawner_wave()
	if actiavtedWaveSystem == true then
		if killedEnemies == spawned then
			spawned = 0
			killedEnemies = 0
			inWave = false
		end
		if timer_wave <= 0 then
			if wave <= maxWave then
				if checked == false then
					wave = wave + 1
					maxEnemies = maxEnemies + 4
					checked = true
				end
				--spawn
				if spawned < maxEnemies then
					CurrentID = math_random(1,#currentWaveSpawnId)
					for l,w in ipairs(enemy_type_database) do
						if w.id == currentWaveSpawnId[CurrentID] then
							enemy_spawn(w.picture,w.picture2,w.frames,player.x - math_random(760,1300),player.y - math_random(350,1100),w.mspeed -math_random(-w.mspeed/10,w.mspeed/10),w.health -math_random(-5,5),w.moveToHitboxX,w.moveToHitboxY,1,w.attackType,w.spawnblood,w.bloodsize -math_random(-2,2),w.bloodsizemax -math_random(-2,2),w.weapon,w.weaponX,w.weaponY,w.damage,true,location,true,w.moneydrop1,w.moneydrop2)
							spawned = spawned + 1
						end
						if w.id == currentWaveSpawnId[CurrentID] then
							enemy_spawn(w.picture,w.picture2,w.frames,player.x - math_random(760,1300),player.y + math_random(350,1100),w.mspeed -math_random(-w.mspeed/10,w.mspeed/10),w.health -math_random(-5,5),w.moveToHitboxX,w.moveToHitboxY,1,w.attackType,w.spawnblood,w.bloodsize -math_random(-2,2),w.bloodsizemax -math_random(-2,2),w.weapon,w.weaponX,w.weaponY,w.damage,true,location,true,w.moneydrop1,w.moneydrop2)
							spawned = spawned + 1
						end
						if w.id == currentWaveSpawnId[CurrentID] then
							enemy_spawn(w.picture,w.picture2,w.frames,player.x + math_random(760,1300),player.y - math_random(350,1100),w.mspeed -math_random(-w.mspeed/10,w.mspeed/10),w.health -math_random(-5,5),w.moveToHitboxX,w.moveToHitboxY,1,w.attackType,w.spawnblood,w.bloodsize -math_random(-2,2),w.bloodsizemax -math_random(-2,2),w.weapon,w.weaponX,w.weaponY,w.damage,true,location,true,w.moneydrop1,w.moneydrop2)
							spawned = spawned + 1
						end
						if w.id == currentWaveSpawnId[CurrentID] then
							enemy_spawn(w.picture,w.picture2,w.frames,player.x + math_random(760,1300),player.y + math_random(350,1100),w.mspeed -math_random(-w.mspeed/10,w.mspeed/10),w.health -math_random(-5,5),w.moveToHitboxX,w.moveToHitboxY,1,w.attackType,w.spawnblood,w.bloodsize -math_random(-2,2),w.bloodsizemax -math_random(-2,2),w.weapon,w.weaponX,w.weaponY,w.damage,true,location,true,w.moneydrop1,w.moneydrop2)
							spawned = spawned + 1
						end
					end
				end
				if spawned == maxEnemies then
					timer_wave = 20
					checked = false
					inWave = true
				end
			else
				actiavtedWaveSystem = false
				enemy = {}
				wave = 0
				timer_wave = -1
				if inMission == true then
					for i,v in ipairs(mission) do
						if v.name == currentMission then
							v.completed = "true"
						end
					end
					--gamestate = "map"
				end
				gamestate = "victoryscreen"
			end
		end
		if inWave == false then
			if love.keyboard.isDown("f5") then
				if timer_wave > 5 then
					timer_wave = 5
				end
			end
		end
		--else
			--if checkedExcessEnemies == false then
				--for l,w in ipairs(enemy) do
					--if w.isWaveMonster == true then
						--table.remove(enemy,i)
						--checkedExcessEnemies = true
					--end
				--end
			--end
	end
end

function enemy_spawner_wave_abandon()
	actiavtedWaveSystem = false
	wave = 0
	maxWave = 10
	inWave = false
	timer_wave = -1
	maxEnemies = 4
	killedEnemies = 0	
	spawned = 0
	checked = false
end

function enemy_spawner_timer()
	if actiavtedWaveSystem == true then
		if inWave == false then
			if timer_wave > -1 then
				if timer_wave < 6 then
					countdown:play()
					countdown:setAttenuationDistances( 0.001, 0.003 )
				end
				timer_wave = timer_wave - 1
			end
		end
	end
end