
textbox = {}

function textbox_add(id,x,y,drawstate,width,height,allowedchars)
	table.insert(textbox,{id = id,x = x,y = y,drawstate = drawstate,width = width,height = height,allowedchars = allowedchars,text = "",selected = false})
end

function textbox_draw()
	for i,v in ipairs(textbox) do
		if gamestate == v.drawstate then
			love.graphics.setColor(110,110,110,255)
			love.graphics.rectangle("fill",v.x,v.y,v.width,v.height)
			love.graphics.setColor(0,0,0,255)
			love.graphics.printf(v.text,v.x,v.y,v.width)
			if v.selected == true then
				love.graphics.setColor(0,148,255,200)
				love.graphics.rectangle("line",v.x -1,v.y -1,v.width +2,v.height +2)
				love.graphics.setColor(0,0,0,255)
				if v.text ~= "" or v.text ~= " " then
					love.graphics.printf("_",v.x + font50:getWidth(v.text),v.y,v.width)
				end
			else
				love.graphics.setColor(0,0,0,255)
				love.graphics.rectangle("line",v.x -1,v.y -1,v.width +2,v.height +2)
			end		
		end
	end
end

function textbox_update()
	for i,v in ipairs(textbox) do
		if love.mouse.isDown(1) then
			if mouseX > scaleWidth * v.x and mouseX < scaleWidth * (v.x + v.width) and
			mouseY > scaleHeight * v.y and mouseY < scaleHeight * (v.y + v.height) then
				v.selected = true
			else
				v.selected = false
			end
		end
		if love.keyboard.isDown("return") then
			if v.selected == true then
				if v.id == "IP" then
					address = v.text
				elseif v.id == "port" then
					port = tonumber(v.text)
				elseif v.id == "username" then
					inputName = v.text
				end
			end
		end
		if v.selected == true then
			if love.keyboard.isDown("v") and love.keyboard.isDown("lctrl") then
				if font:getWidth(love.system.getClipboardText( )) < v.width/2 then
					--if string.find(v.allowedchars,love.system.getClipboardText( )) then
						v.text = love.system.getClipboardText( )
					--end
				end
			end
			if love.keyboard.isDown("c") and love.keyboard.isDown("lctrl") then
				love.system.setClipboardText(v.text)
			end
		end
	end
end

function textbox_input(t)
	for i,v in ipairs(textbox) do
		if v.selected == true and
		font:getWidth(v.text) < v.width/2 then
			if string.find(v.allowedchars,t) then
				v.text = v.text .. t
			end
		end
	end
end

function textbox_keyreleased(key)
	for i,v in ipairs(textbox) do
		if v.selected == true then
			if key == "backspace" then
				v.text = v.text:sub(1,-2)
			end
		end
	end
end