vehicle = {}

function vehicle_spawn(picture,name,id,x,y,maxSpeed,acceleration,fuel,drawPlayer,px,py,bx,by,bw,bh)
	table.insert(vehicle,{picture = picture,name = name,id = id,x = x,y = y,speed = 0,maxSpeed = maxSpeed,acceleration = acceleration,fuel = fuel,px = px,py = py,bx = bx,by = by,bw = bw,bh = bh,direction = 1,inUse = false,vechicleDraw = false})
end

function vehicle_draw_update()
	for i,v in ipairs(vehicle) do
		if v.x > cameraX - v.picture:getWidth() and
		v.x < cameraX + v.picture:getWidth()/2 + cameraWidth and
		v.y > cameraY - v.picture:getHeight() and
		v.y < cameraY + v.picture:getHeight()/2 + cameraHeight then
			v.vechicleDraw = true
			else
			v.vechicleDraw = false
		end
	end
end

function vehicle_draw()
	for i,v in ipairs(vehicle) do
		if v.vechicleDraw then
			love.graphics.draw(v.picture,v.x,v.y,0,v.direction,1,v.picture:getWidth()/2,v.picture:getHeight()/2)
		end
	end
end


local function vehicle_shoot()
	for i,v in ipairs(vehicle) do
		if v.inUse == true then
			if v.id == "katyusha" then
				if v.direction == -1 then
					missiles_spawn(katyusha_rocket, math.rad(-34), v.x, v.y - 25,5, 1200, 5, "player")
				else
					missiles_spawn(katyusha_rocket, math.rad(214), v.x, v.y - 25,5, 1200, 5, "player")
				end
			end
		end	
	end
end

function vehicle_update(dt)
	for i,v in ipairs(vehicle) do
		if v.inUse == true then
			player.x = v.x
			player.y = v.y
			player.allowedToMove = false
			if v.fuel > 0 then
				if love.keyboard.isDown(keys.player_move_up) then
					v.y = v.y - v.speed*dt
				elseif love.keyboard.isDown(keys.player_move_down) then
					v.y = v.y + v.speed*dt
				end
				if love.keyboard.isDown(keys.player_move_left) then
					v.x = v.x - v.speed*dt
					v.direction = 1
				elseif love.keyboard.isDown(keys.player_move_right) then
					v.x = v.x + v.speed*dt
					v.direction = -1
				end
			end
			
			if joystickOn == true then
				local jdirection = joystick:getHat(1)
		
				if v.fuel > 0 then
					if jdirection == "d" then
						v.y = v.y + v.speed*dt
					elseif jdirection == "u" then
						v.y = v.y - v.speed*dt
					end
					if jdirection == "r" then
						v.x = v.x + v.speed*dt
						v.direction = -1
					elseif jdirection == "l" then
						v.x = v.x - v.speed*dt
						v.direction = 1
					end
				end
				if love.keyboard.isDown(keys.player_move_up) or
				love.keyboard.isDown(keys.player_move_down) or
				love.keyboard.isDown(keys.player_move_left) or
				love.keyboard.isDown(keys.player_move_right) or
				jdirection == "u" or
				jdirection == "l" or
				jdirection == "d" or
				jdirection == "r" then
					v.speed = v.speed + v.acceleration*dt
					if v.fuel > 0 then
						v.fuel = v.fuel - v.speed*dt/10
					end
				else
					if v.speed > 0 then
						v.speed = v.speed - 100*dt
					end
				end
			else
				if love.keyboard.isDown(keys.player_move_up) or
				love.keyboard.isDown(keys.player_move_down) or
				love.keyboard.isDown(keys.player_move_left) or
				love.keyboard.isDown(keys.player_move_right) then
					v.speed = v.speed + v.acceleration*dt
					if v.fuel > 0 then
						v.fuel = v.fuel - v.speed*dt/10
					end
				else
					if v.speed > 0 then
						v.speed = v.speed - 100*dt
					end
				end
			end
			
			if v.speed > v.maxSpeed then
				v.speed = v.maxSpeed
			end
			if love.keyboard.isDown(" ") then
				
			end
			cameraX = v.x -cameraWidth/2
			cameraY = v.y -cameraHeight/2
		
			if love.keyboard.isDown("escape") then
				v.x = math.ceil(v.x)
				v.y = math.ceil(v.y)
				player.allowedToMove = true
				player.allowedToDraw = true
				camera_followPlayer = true
				v.speed = 0
				v.inUse = false
				closeMenu = true
			end
			
			--check for map collision
			border_vehicle()
		end
		
		if love.keyboard.isDown(keys.key_shoot) then
			vehicle_shoot()
		end
		
		if v.id == "katyusha" then
			
		end
		
		if player.x > v.x -32 and
		player.x < v.x + v.picture:getWidth()/2 + 32 and
		player.y > v.y - 32 and
		player.y < v.y + v.picture:getHeight()/2 + 32 and
		love.keyboard.isDown("return") then
			player.allowedToMove = false
			player.allowedToDraw = false
			camera_followPlayer = false
			v.speed = v.maxSpeed/3
			v.inUse = true
		end
	end
end

function vehicles_joystick(button)
	for i,v in ipairs(vehicle) do
		if button == 4 then
			if v.inUse == true then
				v.x = math.ceil(v.x)
				v.y = math.ceil(v.y)
				player.allowedToMove = true
				player.allowedToDraw = true
				camera_followPlayer = true
				v.speed = 0
				v.inUse = false
			end
		end
		
		if button == 3 then
			if player.x > v.x -32 and
			player.x < v.x + v.picture:getWidth()/2 + 32 and
			player.y > v.y - 32 and
			player.y < v.y + v.picture:getHeight()/2 + 32 then
				player.allowedToMove = false
				player.allowedToDraw = false
				camera_followPlayer = false
				v.speed = v.maxSpeed/3
				v.inUse = true
			end
		end
		
		if button == 1 then
			vehicle_shoot()
		end
	end
end
