﻿
socket = require "socket"

require "code.load"
require "code.player"
require "code.camera"
require "code.charactercustomizer"
require "code.buttons"
require "code.objects_stay"
require "code.GUI"
require "code.files"
require "code.weapons"
require "code.bullets"
require "code.music" 
require "code.enemy"
require "code.noise"
require "code.blood"
require "code.corpse"
require "code.keys"
require "code.sound"
require "code.trigger"
require "code.npc"
require "code.progress"
require "code.particles"
require "code.weathercycle"
require "code.worlddata"
require "code.imagemanger"
require "code.inventory"
require "code.run"
require "code.joystick"
require "code.scaling"
require "code.vehicles"
require "code.border"
require "code.menu"
require "code.timer"
require "code.garbagereset"
require "code.credits"
require "code.debugmode"
require "code.spawner"
require "code.missiles"
require "code.shop"
require "code.missions"
require "code.damage_text"
require "code.multiplayer.multiplayer_main"
require "code.textboxes"
require "code.options"
require "code.arcade.arcade"
require "code.arcade.arcade_generator"
require "code.arcade.arcade_tile"
require "code.deathscreen"
require "code.easteregg"
require "code.droppedweapons"
require "code.victoryscreen"
require "code.stats"
require "code.reset"
require "code.explosions"
require "code.intro.intro"
require "code.touch"
require "code.NPC_AI"

--libraries
require "code.libs.AnAL"
require "code.libs.tableSer"
require "code.libs.LUBE"
s = require "code.libs.shake"

OS = love.system.getOS() 

gamestate = "menu"
location = "m1"
startlocation = "camp"

function love.load()
	love.graphics.setDefaultFilter("nearest", "nearest")
	
	load()
	image_database()
	menu_load()
	
	easterEgg_load()
	
	music_list_load()
	
	load_data()
	
	objects_stay_load()
	
	camera_load()
	
	trigger_list()
	
	joystick_load()
	
	GUI_load()
	
	arcade_load()

	enemy_type_database_load()
	
	button_spawn(tab,tab_over,4,18,"Skin",2,2,"cc",-1,true,"skin",font)
	button_spawn(tab,tab_over,72,18,"Eyes",2,2,"cc",-1,true,"eyes",font)
	button_spawn(tab,tab_over,140,18,"Hair",2,2,"cc",-1,true,"hair",font)
	button_spawn(tab,tab_over,208,18,"Weapons",2,2,"cc",-1,true,"other",font)
	
	button_spawn(button_skin_1,button_skin_1,10,60,"",2,2,"cc",-1,false,"skin_1",font50)
	button_spawn(button_skin_2,button_skin_2,148,60,"",2,2,"cc",-1,false,"skin_2",font50)
	button_spawn(button_skin_3,button_skin_3,10,198,"",2,2,"cc",-1,false,"skin_3",font50)
	button_spawn(button_skin_4,button_skin_4,148,198,"",2,2,"cc",-1,false,"skin_4",font50)
	button_spawn(button_skin_5,button_skin_5,10,336,"",2,2,"cc",-1,false,"skin_5",font50)
	button_spawn(button_skin_6,button_skin_6,148,336,"",2,2,"cc",-1,false,"skin_6",font50)
	button_spawn(button_eyes_1,button_eyes_1,10,60,"",2,2,"cc",-2,false,"eyes_1",font50)
	button_spawn(button_eyes_2,button_eyes_2,148,60,"",2,2,"cc",-2,false,"eyes_2",font50)
	button_spawn(button_eyes_3,button_eyes_3,10,198,"",2,2,"cc",-2,false,"eyes_3",font50)
	button_spawn(button_hair_1,button_hair_1,10,60,"",2,2,"cc",-3,false,"hair_1",font50)
	button_spawn(button_hair_2,button_hair_2,148,60,"",2,2,"cc",-3,false,"hair_2",font50)
	button_spawn(button_hair_3,button_hair_3,10,198,"",2,2,"cc",-3,false,"hair_3",font50)
	button_spawn(button_hair_4,button_hair_4,148,198,"",2,2,"cc",-3,false,"hair_4",font50)
	button_spawn(khc_14,khc_14,10,60,"",2,2,"cc",-4,false,"gun1",font50)

	button_spawn(button_1,button_2,512,220,"Start",2,2,"menu",0,true,"start",font50)
	button_spawn(button_1,button_2,512,304,"Options",2,2,"menu",0,true,"options",font50)
	button_spawn(button_1,button_2,512,388,"Credits",2,2,"menu",0,true,"credits",font50)
	button_spawn(button_1,button_2,512,472,"Website",2,2,"menu",0,true,"website",font50)
	button_spawn(button_1,button_2,512,556,"Quit",2,2,"menu",0,true,"quit",font50)
	
	button_spawn(gamemodeButton3_2,gamemodeButton3,33,250,"",2,2,"gamemodeSelection",0,true,"skirmish",font50)
	button_spawn(gamemodeButton1_2,gamemodeButton1,460,250,"",2,2,"gamemodeSelection",0,true,"campaign",font50)
	button_spawn(gamemodeButton2_2,gamemodeButton2,886,250,"",2,2,"gamemodeSelection",0,true,"multiplayer",font50)
	button_spawn(button_1,button_2,510,600,"Back",2,2,"gamemodeSelection",0,true,"backtomenu",font50)
	
	button_spawn(button_1,button_2,512,566,"Connect",2,2,"multiplayer_setup",0,true,"connect",font50)
	
	button_spawn(button2_1,button2_2,10,10,"Back",2,2,"options",0,true,"backtomainmenu-options",font50)
	
	--button_spawn(button2_1,button2_2,0,0,"Back",2,2,"arcade",0,true,"backtogamemodemenu",font50)
	
	button_spawn(button2_1,button2_2,0,0,"Back",2,2,"multiplayer_setup",0,true,"backtogamemodemenu",font50)
	
	button_spawn(button2_1,button2_2,130,645,"Back",2,645,"map",0,true,"backtogamemodemenu",font50)
	
	button_spawn(button2_1,button2_2,1020,645,"Start",2,2,"map",0,true,"startmission",font50)

	button_spawn(button_1,button_2,272,600,"Spawn",2,2,"multiplayer",-6,false,"spawn",font50)
	
	button_spawn(questionmark_1,questionmark_2,1190,10,"",2,2,"map",0,true,"help_map",font50)
	--button_spawn(spetnazbook_1,spetnazbook_2,1205,52,"",2,2,"map",0,true,"help_map_2",font50)
	
	button_spawn(button_1,button_2,1010,10,"sRGB",2,2,"options",0,true,"sRGB",font50)
	button_spawn(button_1,button_2,1010,94,"Retina mode",2,2,"options",0,true,"retinamode",font50)
	button_spawn(button_1,button_2,1010,178,"MSAA",2,2,"options",0,true,"MSAA",font50)
	button_spawn(button_1,button_2,1010,262,"Disable Particles",2,2,"options",0,true,"particles",font50)
	button_spawn(button_1,button_2,1010,344,"Fullscreen",2,2,"options",0,true,"fullscreen",font50)
	
	button_spawn(button2_1,button2_2,1010,448,"+",2,2,"options",0,true,"sound+",font50)
	button_spawn(button2_1,button2_2,1138,448,"-",2,2,"options",0,true,"sound-",font50)
	button_spawn(button_1,button_2,1010,522,"Music",2,2,"options",0,true,"Music",font50)
	button_spawn(button_1,button_2,1010,596,"SFX",2,2,"options",0,true,"SFX",font50)
	
	button_spawn(button_1,button_2,20,25,"Back",2,2,"skirmish",0,true,"backtogamemodemenu",font50)
	button_spawn(button_1,button_2,20,125,"Survival",2,2,"skirmish",0,true,"survivalmenu",font50)
	button_spawn(button_1_unclickable,button_2_unclickable,20,225,"Disabled",2,2,"skirmish",0,true,"arcade_",font50)
	
	button_spawn(button_1,button_2,512,125,"Town",2,2,"survivalmenu",0,true,"SurvivalMap1",font50)
	button_spawn(button_1,button_2,512,225,"Scrapyard",2,2,"survivalmenu",0,true,"SurvivalMap2",font50)
	button_spawn(button_1,button_2,512,325,"Village",2,2,"survivalmenu",0,true,"SurvivalMap3",font50)
	button_spawn(button_1,button_2,512,425,"Hell's Highway",2,2,"survivalmenu",0,true,"SurvivalMap4",font50)
	button_spawn(button2_1,button2_2,0,0,"Back",2,2,"survivalmenu",0,true,"backtoskirmishmenu",font50)
	
	button_spawn(button_1,button_2,20,20,"Resume",2,2,"playing",-10,false,"resume",font50)
	button_spawn(button_1,button_2,20,120,"Exit to menu",2,2,"playing",-10,false,"backtomenu",font50)
	button_spawn(button_1,button_2,20,220,"Exit to desktop",2,2,"playing",-10,false,"quit",font50)
	
	--enemy_spawn(zombie,zombie_spritesheet,4,0,0,100,2,48,10,1,"melee",true,20,30,"",0,0,80,false,"m1",false,10,20,true,"repeat",true,1,{100,200,300,400,500,600,700,800},{100,100,80,100,120,100,100,100})
	--enemy_spawn(bandit,bandit_spritesheet,4,0,0,100,2,48,10,1,"ranged",true,20,30,"KHC-14",0,10,80,false,"m1",false,10,20,true,"repeat",true,1,{100,200,300,400,500,600,700,800},{100,100,80,100,120,100,100,100})
	
	npc:spawn(npc1,975,-58,1,{"Hello soldier!","Im glad to see our military power isn't completely gone."},"Anna","Korliki","","",0,0)
	--npc:spawn(npc1,620,240,1,{"I wonder how it's going in Moscow","Hello"},"Akilina","wasteland","","",0,0)
	npc:spawn(npc6,690,216,1,{"Do you have any Vodka?","Hello, my friend!"},"Grisha","Pesha","shop","",0,0)
	npc:spawn(npc3,652,255,1,{"Vodka helps with the cold weather","Hello, my friend!"},"Artyom","Korliki","","",0,0)
	npc:spawn(npc5,1490,28,1,{"Highest quality goods in town, chuvak!","Need ammo, my friend?"},"Petr","Korliki","shop","",0,0)
	npc:spawn(soldier,1070,250,1,{"Do you have any Vodka?","Hello, my friend!"},"Oleg","Pesha","shop","",0,0)
	npc:spawn(soldier,970,450,1,{"Do you have any Vodka?","Hello, my friend!"},"David Kh.","Pesha","","",0,0)
	npc:spawn(soldier,170,420,1,{"Do you have any Vodka?","Hello, my friend!"},"Andrei","Pesha","","",0,0)
	npc:spawn(npc7,670,700,1,{"Hello","What are you doing out here in the cold?"},"Alisa Kudrow","Pesha","","",0,0)
	npc:spawn(npc8,770,700,1,{"Do you have any Vodka?","Hello, my friend!"},"Elena","Pesha","","",0,0)
	
	npc:spawn(soldier,700,270,1,{"Do you have any Vodka?","Hello, my friend!"},"Boris","s1","shop","",0,0)
	npc:spawn(npc2,940,240,1,{"Do you have any Vodka?","Hello, my friend!"},"Mikhail Rosen","s2","shop","",0,0)
	npc:spawn(npc5,900,480,1,{"Wanna buy some illegal guns?","I have guns for all needs!"},"Aleksey","s3","shop","",0,0)
	npc:spawn(npc5,750,230,1,{"Let's sing a song together!","Hello, my friend!"},"Anatoli","s4","shop","",0,0)
	
	--vehicle_spawn(car_red,-100,0,200,40,false,0,0,0,0,0,0)
	--vehicle_spawn(car_red,"F2-19","",-100,50,300,125,500,false,0,0,bx,by,bw,bh)
	--vehicle_spawn(transporter,"F3-21","",200,440,400,170,900,false,0,0,bx,by,bw,bh)
	--vehicle_spawn(katyusha,"BM-13 aka Katyusha","katyusha",400,440,300,170,1200,false,0,0,bx,by,bw,bh)
	
	textbox_add("IP",440,300,"multiplayer_setup",400,30,"0 1 2 3 4 5 6 7 8 9 .")
	textbox_add("port",440,360,"multiplayer_setup",400,30,"0 1 2 3 4 5 6 7 8 9 .")
	textbox_add("username",440,420,"multiplayer_setup",400,30,"a b c d e f g h i j k l m n o p q r s t u v w x y z A B C D E F G H I J K L M N O P Q R S T U V W X Y Z 0 1 2 3 4 5 6 7 8 9")
	
	weather_load()
	
	credits_load()
	
	shop_load_items()
	
	objects_stay_update()
	npc:draw_update()
	
	missions_load()
	
	mSound_database()
	
	selectionScreen_load()
	
	options_menu_load()
	
	love.audio.setDopplerScale(0)
	
	collectgarbage()
	
	love.graphics.setBackgroundColor(235,235,235)
end

local gamemodeScreenDarkTransparency = 255
local gamemodeScreenDarkTransparencyGoDown = true

function love.draw()
	if gamestate == "playing" then
		love.graphics.setColor(255,255,255)
		love.graphics.scale(zoom,zoom)
		love.graphics.setFont(font)
		camera_push()
		camera_translate()
		objects_stay_draw_background_static()
		blood_draw()
		corpse_draw()
		objects_stay_draw_background()
		npc:draw()
		--vehicle_draw()
		enemy_draw()
		explosion_draw()
		player_draw()
		weapon_draw()
		npc:draw2()
		particles_draw_camera()
		bullet_draw()
		drawText()
		missiles_draw()
		objects_stay_draw()
		npc:draw_text()
		camera_pop()
		particles_draw_igonore_camera()
		GUI_draw()
		shop_draw()
		debugMode_draw()
		love.graphics.setColor(0,0,0,255)
		--love.graphics.print("Secounds: " .. tostring(gameSeconds),100,0)
		--love.graphics.print("Alpha time: " .. tostring(at),200,0)
		if pausedGame == true then
			love.graphics.setColor(0,0,0,100)
			love.graphics.rectangle("fill",0,0,1280,720)
			love.graphics.setColor(255,255,255,255)
			love.graphics.print("Game paused!",1160,0)
		end
		love.graphics.setColor(255,255,255,255)
		inventoryItem_draw()
	elseif gamestate == "loadingScreen" then
		
	elseif gamestate == "menu" then
		love.graphics.setColor(255,255,255)
		love.graphics.setFont(font50)
		love.graphics.push()
		love.graphics.translate(-player.x + cameraWidth/2,-player.y + cameraHeight/2)
		objects_stay_draw_background_static()
		objects_stay_draw_background()
		blood_draw()
		corpse_draw()
		enemy_draw()
		explosion_draw()
		--vehicle_draw()
		bullet_draw()
		missiles_draw()
		objects_stay_draw()
		love.graphics.pop()
		love.graphics.scale(scaleWidth,scaleHeight)
		love.graphics.draw(viginette,0,0)
		love.graphics.setColor(0,0,0,255)
		love.graphics.setFont(font)
		love.graphics.print("Made by RadioactiveGears - Development: 2014 to 2017",5,705)
		love.graphics.setColor(255,255,255,255)
		particles_draw_igonore_camera()
		love.graphics.setColor(30,30,30,60)
		love.graphics.rectangle("fill",0,0,1280,720)
		love.graphics.setColor(255,255,255,255)
		menu_draw()
		love.graphics.draw(mainmenuicon,640,50,0,1,1,mainmenuicon:getWidth()/2)
		love.graphics.scale(1,1)
	elseif gamestate == "cc" then
		love.graphics.scale(scaleWidth,scaleHeight)
		love.graphics.setFont(font)
		cc_draw()
		love.graphics.scale(1,1)
	elseif gamestate == "options" then
		love.graphics.setColor(255,255,255,255)
		love.graphics.setFont(font50)
		love.graphics.push()
		love.graphics.translate(-player.x + cameraWidth/2,-player.y + cameraHeight/2)
		s:set()
		objects_stay_draw_background_static()
		objects_stay_draw_background()
		blood_draw()
		corpse_draw()
		enemy_draw()
		explosion_draw()
		bullet_draw()
		missiles_draw()
		objects_stay_draw()
		s:unset()
		love.graphics.pop()
		love.graphics.scale(scaleWidth,scaleHeight)
		love.graphics.draw(viginette,0,0)
		options_menu_draw()
		love.graphics.setColor(255,255,255,255)
		particles_draw_igonore_camera()
		love.graphics.setColor(30,30,30,60)
		love.graphics.rectangle("fill",0,0,1280,720)
	elseif gamestate == "credits" then
		love.graphics.setColor(255,255,255)
		love.graphics.setFont(font50)
		love.graphics.push()
		love.graphics.translate(-player.x + cameraWidth/2,-player.y + cameraHeight/2)
		objects_stay_draw_background_static()
		blood_draw()
		corpse_draw()
		enemy_draw()
		explosion_draw()
		objects_stay_draw_background()
		--vehicle_draw()
		bullet_draw()
		objects_stay_draw()
		love.graphics.pop()
		love.graphics.scale(scaleWidth,scaleHeight)
		love.graphics.draw(viginette,0,0)
		love.graphics.setColor(255,255,255,255)
		particles_draw_igonore_camera()
		love.graphics.setColor(30,30,30,60)
		love.graphics.rectangle("fill",0,0,1280,720)
		credits_draw()
	elseif gamestate == "map" then
		love.graphics.scale(scaleWidth,scaleHeight)
		missions_draw()
	elseif gamestate == "gamemodeSelection" then
		love.graphics.scale(scaleWidth,scaleHeight)
		love.graphics.setColor(255,255,255,255)
		love.graphics.draw(gamemodeSelectionBackground,0,0)
		love.graphics.draw(gamemodeSelectionBackground_title,640,20,0,1,1,gamemodeSelectionBackground_title:getWidth()/2)
		love.graphics.setColor(255,255,255,gamemodeScreenDarkTransparency)
		love.graphics.draw(gamemodeSelectionBackground_dark,0,0)
		love.graphics.setColor(255,255,255,255)
	elseif gamestate == "multiplayer_setup" then
		love.graphics.scale(scaleWidth,scaleHeight)
		love.graphics.setColor(255,255,255)
		love.graphics.draw(background_multiplayer_setup,0,0)
		mutliplayer_setup_draw()
		textbox_draw()
	elseif gamestate == "multiplayer" then
		multiplayer_draw()
	elseif gamestate == "arcade" then
		love.graphics.scale(scaleWidth,scaleHeight)
		arcade_draw()
	elseif gamestate == "skirmish" then
		love.graphics.scale(scaleWidth,scaleHeight)
		love.graphics.setColor(255,255,255,255)
		love.graphics.draw(skirmishbackground,0,0)
	elseif gamestate == "survivalmenu" then
		love.graphics.scale(scaleWidth,scaleHeight)
		love.graphics.setColor(255,255,255,255)
		objects_stay_draw_background_static()
		objects_stay_draw_background()
	elseif gamestate == "deathscreen" then
		love.graphics.scale(scaleWidth,scaleHeight)
		deathscreen_draw()
	elseif gamestate == "victoryscreen" then
		love.graphics.scale(scaleWidth,scaleHeight)
		victoryscreen_draw()
	elseif gamestate == "splashscreen" then
		intro_draw()
	end
	button_draw()
end

pausedGame = false

function love.update(dt)
	mouseX, mouseY = love.mouse.getPosition()
	music_entry_play()
	if gamestate == "playing" then
		if pausedGame == false then
			s:update(dt)
			player_update(dt)
			camera_update(dt)
			bullet_move(dt)
			bullet_remove()
			ivenotoryItem_update(dt)
			enemy_update(dt)
			noise_field_update(dt)
			trigger_update(dt)
			music_entry_play()
			vehicle_update(dt)
			explosion_update(dt)
			menu_pause()
			blood_update(dt)
			advancedSound_update()
			border()
			weather_update(dt)
			garbage_collect()
			updateText(dt)
			GUI_update(dt)
			weapon_update(dt)
			particles_update(dt)
			npc:functions(dt)
			enemy_spawner_wave()
			--enemy_spawner_update()
			timer_update()
			corpse_update()
			missiles_move(dt)
			shop_update()
			player_die()
			objects_stay_update()
			npc:draw_update()
			corpse_draw_update()
			--vehicle_draw_update()
			weapon_shoot(dt)
			if not wind:isPlaying( ) then
				wind:play()
			end
		end
	elseif gamestate == "menu" then
		weather_update(dt)
		menu_update(dt)
		particles_update(dt)
		timer_update()
		objects_stay_update()
	elseif gamestate == "credits" then
		credits_update(dt)
		weather_update(dt)
		particles_update(dt)
		timer_update()		
		objects_stay_update()
	elseif gamestate == "map" then
		missions_update(dt)
	elseif gamestate == "multiplayer_setup" then
		multiplayer_setup_update()
		textbox_update()
	elseif gamestate == "multiplayer" then
		multiplayer_update(dt)
		selectionScreen_update()
	elseif gamestate == "deathscreen" then
		deathscreen_update()
	elseif gamestate == "victoryscreen" then
		victoryscreen_update()
	elseif gamestate == "gamemodeSelection" then
		if gamemodeScreenDarkTransparencyGoDown == true then
			gamemodeScreenDarkTransparency = gamemodeScreenDarkTransparency - 20*dt
		else
			gamemodeScreenDarkTransparency = gamemodeScreenDarkTransparency + 20*dt
		end
		if gamemodeScreenDarkTransparency <  150 then
			gamemodeScreenDarkTransparencyGoDown = false
		elseif gamemodeScreenDarkTransparency > 253 then
			gamemodeScreenDarkTransparencyGoDown = true
		end
	elseif gamestate == "options" then
		weather_update(dt)
		particles_update(dt)
		timer_update()
		objects_stay_update()
	elseif gamestate == "survivalmenu" then
		objects_stay_update()
	elseif gamestate == "splashscreen" then
		intro_update(dt)
	end
	button_update()
end

function love.run()
	runfile()
end

function love.textinput(t)
	if gamestate == "multiplayer_setup" then
		textbox_input(t)
	end
end

function love.keypressed(key)
	if gamestate == "playing" then
		if pausedGame == false then
			npc:triggertext(key)
			npc:special(key)
			inventory_open(key)
			debugMode_activate(key)
		end
		if key == "escape" and
		shop == false then
			pausedGame = not pausedGame
		end
		if gamestate == "playing" then
			if pausedGame == true then
				layer = -10
			else
				layer = -1
			end
		end
	end
end

function love.keyreleased(key)
	textbox_keyreleased(key)
	if gamestate == "playing" then 
		shop_key(key)
	elseif gamestate == "multiplayer" then
		multiplayer_keyreleased(key)
	end
end

function love.quit()
	if gamestate == "multiplayer" then
		mutliplayer_disconnect()
	end
	save_data()
end

function love.mousepressed(x,y,buttonId)
	button_press(buttonId)
end

function love.mousereleased(x,y,button)
	shop_click(button)
	if gamestate == "map" then
		missions_mouse(x,y,button)
	end
end

function love.joystickpressed(joystick,button)
    if gamestate == "playing" then
		weapon_shoot_joystick(button)
		--vehicles_joystick(button)
		npc:triggertext_joystick(button)
    end
	print(button)
end
